#ifndef __TPhSensorMapDB__
#define __TPhSensorMapDB__

///////////////////////////////////////////////////////////////////////
//
// TPhSensorMapDB manages the (Sensor, Row, Col) <-> (FEC, String, ChPos)
// Mapping. 
//
// $Id: TPhSensorMapDB.h,v 1.2 1998/05/23 22:21:52 decowski Exp $
//
///////////////////////////////////////////////////////////////////////

// Phobos classes

class TPhSensorMapDBSensorItem;
class TPhSensorMapDBFECItem;

// Root classes
#include "TNamed.h"
#include "THashTable.h"
#include "TObjArray.h"

class TPhSensorMapDB : public TNamed {

private:
  THashTable *fSensorTable; //The Hash table SensorItems are stored
  TObjArray  *fFECTable;    //The Object table where FECItems are stored
  Int_t fVerbose;           //! Verbosity flag

public:
  TPhSensorMapDB();
  virtual ~TPhSensorMapDB();

  Bool_t      ReadASCIIData(Char_t *FileName);
  Bool_t      Lookup(Char_t *SensorName, Int_t Row, Int_t Col, 
		     Int_t *FEC, Int_t *String, Int_t *ChPos, 
		     Int_t *BondPat);
  Bool_t      Lookup(Char_t *SensorName, Int_t Row, Int_t Col, 
		     Int_t *FEC, Int_t *String, Int_t *ChPos);

  Bool_t      Lookup(Int_t FEC, Int_t String, Int_t ChPos, 
		     Char_t *Sensor, Int_t *Row, Int_t *Col, 
		     Int_t *BondPat, Int_t *Pad);
  Bool_t      Lookup(Int_t FEC, Int_t String, Int_t ChPos, 
		     Char_t *Sensor, Int_t *Row, Int_t *Col);

  void        ls(Option_t *option);

  TPhSensorMapDBSensorItem* GetSensor(Char_t *Name);
  TPhSensorMapDBFECItem*    GetFEC(Int_t Num);

  void        SetVerbose(Int_t Verbose) { fVerbose = Verbose; }
  Int_t       GetVerbose() { return fVerbose; }

  ClassDef(TPhSensorMapDB,1) //Sensor Mapping Manager

};

#endif // __TPhSensorMapDB__
