#ifndef __TPhSensorMapDBFECItem__
#define __TPhSensorMapDBFECItem__

///////////////////////////////////////////////////////////////////////
//
// TPhSensorMapDBFECItem stores the (Sensor, Row, Col) lookup map for  
// a given FEC.
//
// $Id: TPhSensorMapDBFECItem.h,v 1.7 1999/02/25 00:16:06 olszewsk Exp $
//
///////////////////////////////////////////////////////////////////////

// Phobos classes

// Root classes
#include "TObject.h"

// Phat classes
#include "TPhString.h"

//const Int_t kNumStrings = 8;    //Number of strings in an FEC
//const Int_t kMaxChannels = 768; //Maximal number of channels in a string

class TPhSensorMapDBFECItem : public TObject {

private:

// This is the (Sensor,Row,Col) element that we will store 
struct SensorMap_t {
  Char_t  Sensor[5];
  Short_t Row;
  Short_t Column;
  Short_t BondPat;
};

  Short_t      fFEC;                       //The FEC number   
  Short_t      fStringLength[kNumStrings]; //The lengths in the strings
  SensorMap_t  *fString[kNumStrings];      //The Maps of the strings

public:
  TPhSensorMapDBFECItem();
  TPhSensorMapDBFECItem(Int_t FEC);

  virtual ~TPhSensorMapDBFECItem();

  void   Store(Int_t String, Int_t ChPos, 
	       Char_t *Sensor, Int_t Row, Int_t Col, Int_t BondPat);

  Bool_t Lookup(Int_t String, Int_t ChPos, 
		Char_t *Sensor, Int_t *Row, Int_t *Col, Int_t *BondPat);

  void   ls(Option_t *)
    { printf("FEC Number: %d\n", fFEC); }
  void   Print(Option_t *option = "");

  Int_t  GetFEC() { return fFEC; }
  Int_t  GetStringLength(Int_t String)
    { return fStringLength[String]; }

  Int_t  GetNStrings();

  ClassDef(TPhSensorMapDBFECItem,1) //Do (FEC,Str,ChP)->(Sensor,Row,Col) map

};

#endif // __TPhSensorMapDBFECItem__
