// Made by A.O. on 30.04.1998
// Updated by A.O. on 7.01.1999  run+parameters, convenient getting of input file name
// Converts .AOU ascii output files from Phobos MC Geant based program
// to root format, creating MCTracks, MCHits and HitArraysFromHits data containers 
// for each event.
main(Char_t *inputfile=NULL, Int_t runno, Int_t startevno)
{
    gROOT.Reset();

    TPhEvent *event;

    Char_t inputpathname[100];
    Char_t outputpathname[100];
    Char_t InputFileName[100];
    Char_t OutputFileName[100];
    Char_t FullFileName[100];
    Char_t EventName[20];

    const Char_t *phathome = gSystem->Getenv("PHATHOME");

    if(!inputfile) {
      // Prompt for file to be opened. Depending on navigation in
      // dialog the current working directory can be changed.
      // The returned file name is always with respect to the
      // current directory.
      // input
      const char *gOpenAsTypes[] = {
	"AOU files",   "*.aou",
	"APX files",  "*.apx",
	0, 0
      };
      
      TGFileInfo fi;
      fi.fFileTypes = gOpenAsTypes;
      fi.fFilename = NULL;
      fi.fIniDir = phathome;
      if(!gROOT->IsBatch()) {
	new TGFileDialog(gClient->GetRoot(), gClient->GetRoot(), kFDOpen, &fi);
      }
      if(fi.fFilename!=NULL) {
	if(strcmp(fi.fFilename,""))
	  sprintf(FullFileName,"%s",fi.fFilename);
      } else {
	// This is the filename of the AOU file that gets converted
	// if File Dialog did not get the name
	sprintf(inputpathname,"%s/data",phathome); 
	sprintf(InputFileName,"hijing_2cen.aou");
	sprintf(FullFileName,"%s/%s",inputpathname,InputFileName);
      }
    } else strcpy(FullFileName,inputfile);
      
    TPhASCIIData *inputdata = new TPhASCIIData(FullFileName, runno, startevno);
    if( !inputdata ) {
      fprintf(stderr,
	      "ConvAouToPixedRoot: problems creating TPhASCIIData object - exiting.");
      exit(0);
    }

    // output
    strcat(FullFileName,".root");
    TFile *outputdata = new TFile(FullFileName,"RECREATE");
    if( !outputdata ) {
       fprintf(stderr,"ConvAouToPixedRoot: can not create %s output file - exiting.",FileName);
       exit(0);
    }

    // Attention!, pointer to TPhDetector object is known only after
    // first event has been converted (AOU header has been read).
    // So only then the pointer value can be taken.
    TPhDetector *detector;

    TPhRun *run;
    run = inputdata->GetRun();

    int cnt = 0;
    while( event = inputdata->GetNextEvent() ) {
      // data containers has been created and registered with the event object
      // HitArraysFromHits data container will be created next. 
      detector = TPhDetector::GetInstance();
      detector->SetEvent(event);
      detector->MakeHitArraysOutOfHits("MCHits","HitArraysFromHits");

      outputdata.cd();
      event->Write();
      event->ls("C");
      delete event;
      cnt++;
    }

    run->Write();
    detector->Write();
    inputdata.Close();
    outputdata.Close();
}

