// Made by A.O. on 27.04.1998
// Updated by A.O. on 07.01.1999  detector taken only from the input file
// Creates TPhHitArrays out of (MC)hits and puts them into an event container.
main(Char_t *inputfile=NULL)
{
    gROOT.Reset();

    TPhEvent *event;

    Char_t pathname[100];
    Char_t InputFileName[100];
    Char_t FileName[100];
    Char_t EventName[20];

    const Char_t *phathome = gSystem->Getenv("PHATHOME");

//  Create a TPhDST object for accessing the ROOT data file
//  Standard input root file name.
    sprintf(InputFileName,"%s","hijing_2cen.aou.root");
    sprintf(FileName,"%s/data/%s",phathome,InputFileName); 

    if(inputfile) 
      strcpy(FileName,inputfile);

    TPhDST *inputdata = new TPhDST();
    if(!inputdata->Open(FileName)) {
      fprintf(stderr,"ConvRootToPixedRoot: can not open %s input file - exiting.\n",FileName);
      return;
    }

//  A detector saved in a ROOT file should be used
    TPhDetector *detector = NULL;
    detector = inputdata->GetDetector();
    if(detector) 
      printf("TPhDetector ver.%f found in %s\n", detector->GetVersion(), FileName);
    else {
      printf("ConvRootToPixedRoot: Can't find a TPhDetector object in the input file\n");
      return;
    }

    Char_t *change = strstr(FileName,".root");
    sprintf(change,"%s",".arrays.root");
    TFile *outputdata = new TFile(FileName,"RECREATE");
    if( !outputdata ) {
      fprintf(stderr,"ConvRootToPixedRoot: can not create %s output file - exiting.\n",FileName);
      return;
    }

    int cnt = 0;
    while( event = inputdata->GetNextEvent() ) {
      detector->SetEvent(event);
      detector->MakeHitArraysOutOfHits("MCHits","HitArraysFromHits");
      // detector has created hitarays and registered them with the event object
      outputdata.cd();
      event->Write();
      event->ls("C");
      delete event;
      cnt++;
    }

    detector->Write();
    inputdata.Close();
    outputdata.Close();
}

