// FindVertex.C: This macro show how to find the vertex of an event. 
// mpd 980817
//
// $Id: FindVertex.C,v 1.3 1999/02/10 17:08:13 decowski Exp $
{
  gROOT->Reset();
// Create the detector
  TPhDetector *det;
  if((det = TPhDetector::GetInstance()) == NULL)
    det = TPhDetector::ReadLatestGeometry();

  TPhEvent *ev;

  // This is a sample file with 10 events with random verteces
  TPhDST *data = new TPhDST("$PHATHOME/data/hijing_2cen.adat.root");

  // Loop over all events
  while(ev = data.GetNextEvent()) {
    // The vertex is reconstructed from hitarrays that are in the 
    // sensors, so we first need to fill the sensors. 
    det->SetEvent(ev);
    det->FillWithEventHitArrays("PMCHitArraysFromHits");
    gBenchmark->Start("v");
    ev->FindVertex();
    gBenchmark->Show("v");
    gBenchmark->Reset();

    // This will produce a canvas with some diagnostics
    ev->DisplayVertex();

    // The vertex finder created a new object called "MainVertex" that is
    // included in the event (you will now have to write the event out to
    // file if you want to keep it). 
    TPhVertex *vtx = ev->GetObject("MainVertex");
    if(vtx)
      printf("Vertex at %f %f %f\n", vtx->GetX(), vtx->GetY(), vtx->GetZ());
    delete ev;
  }
}
