//tmp
{
  gROOT->Reset();

  // Get Sensor Database
  TFile f("$PHATHOME/init/SensorDB.root");
  TPhSensorMapDB* SensDB = (TPhSensorMapDB*) f.Get("SensDB");
  f.Close();
  SensDB->SetVerbose(1);

  // Get Detector object
  TFile detectorDB("$PHATHOME/init/test/Detector.root");
  TPhDetector *det = detectorDB.Get("LatestGeometry");
  detectorDB.Close();

  // Open data file with FEC buffers. Use RawDataMaker.C to make it. 
  TFile outfile("out_trans.root", "recreate");
  TPhDST data("out.root");
  TPhEvent *event;

  Int_t i, j;
  Int_t FEC, String, ChPos, BondPat;
  Char_t SensorName[10], FECName[10];
  Int_t ADC;

  TPhHitArray *HitArray, *BackTrHitArray;
  TPhRawHitFECn0 *RawBuf;
  TPhSensor *Sensor;

  FECRawHit_t Hit;

event = data.GetNextEvent();

  //  while(event = data.GetNextEvent()) {
    TPhAbsDataContainer *RawBufCont = event->GetObject("MCRawData");
    TPhHashContainer *HitArrayCont = (TPhHashContainer*) 
      event->GetObject("MCHitArrays");

    // Container holding the backtranslated hits
    TPhHashContainer *BackTrHitArrayCont = 
      new TPhHashContainer("MCHitArraysFromFECs");

    TIter NextFEC(RawBufCont->GetIterator());

    // Loop over all FECs
    while(RawBuf = (TPhRawHitFECn0*) NextFEC()) {

      // Get the FEC number
      FEC = RawBuf->GetFECNum();
      // Loop over all 8 strings
      for(String = 0; String < 8; String++) {
	FECRawHit_t *Data = RawBuf->GetRawHitArray(String);
	// Loop over all the channels in a string
	for(ChPos = 0; ChPos < RawBuf->GetRawHitArraySize(String); ChPos++) {
	  // Do (FEC, String, ChPos) -> (Sensor, Row, Col) lookup
	  if(SensDB->Lookup(FEC, String, ChPos, SensorName, &i, &j)) {
	    ADC = Data[ChPos].ADC;
	    // Find a hitarray with the given name in the original container
	    // "MCHitArrays"
	    HitArray = (TPhHitArray*) HitArrayCont->GetObject(SensorName);
	    if(HitArray) {
	      // Comparte the ADC value in the FEC and the one in the 
	      // original HitArray. The value in the hitarray can sometimes
	      // be > 4096, which is an error! the ADC value should be 12-bit
	      if(ADC != HitArray->GetADC(i, j) 
		 && HitArray->GetADC(i, j) != -1 
		 && HitArray->GetADC(i, j) < 4096) {
		printf("Problem: %s (%d, %d): %d %d\n", SensorName, i, j,
		       HitArray->GetADC(i, j), ADC);
	      }
	    }
	    // Get the HitArray from the new "MCHitArraysFromFECs" container
	    BackTrHitArray = 
	      (TPhHitArray*) BackTrHitArrayCont->GetObject(SensorName);

	    // Create the HitArray in the container if it hasn't been created
	    // before
	    if(!BackTrHitArray) {
	      Sensor = det->GetSensor(SensorName);
	      if(!Sensor) {
		printf("Non existant sensor: %s\n", SensorName);
		return;
	      }
	      BackTrHitArray = new TPhHitArray(Sensor, SensorName, 
					       "Translated from FEC");
	      BackTrHitArrayCont->Add((TPhDataObject*)BackTrHitArray);
	    }
	    
	    BackTrHitArray->SetADC(i, j, ADC);
	    // After some investigation, it seems that the very outer 
	    // spectrometer sensors (PO* and PP*) do not necessarily have
	    // to have any hits, even in a central collision, 
	    // so they might not be in the "MCHitArrays" container!
// 	    else {
// 	      printf("HitArray %s not found in original container! ", 
// 		     SensorName);
// 	      printf("FEC = %d, String = %d, ChPos = %d\n", 
// 		   FEC, String, ChPos);
//	    }
	  }
	  else {
	    printf("Couldn't do FEC = %d, String = %d, ChPos = %d lookup!\n", 
		   FEC, String, ChPos);
	  }
	}
      }
    }
    // Add the new container to the event and write it out. 
    event->AddObject(BackTrHitArrayCont);
    outfile.cd();
    event->Write();
    data.GetFile()->cd();
    //  } // while(event = data.GetNextEvent()) {
    data.Close();
}
