// Benchmark the Phat distribution
// This macro executes a bunch of other macros, to see if
// the distribution is consistent
//
// Created 980717: mpd
{
  gROOT->Reset();

  // Add all the macros that should be executed here. The last name has 
  // to be """". 
  Char_t *Macros[] = { "checkdetector.C", 
		       "checkmul.C", "checkon.C", ""};
  Char_t *CurrentMacro;
  Char_t Line[100];
  Char_t ShellCmd[100];
  Int_t BadBehavior = 0;

  // Setup the file we want to write to
  gSystem->Exec("rm -f BenchResult.out; touch BenchResult.out");
  Int_t i = 0, j;
  Char_t *ret_string;
  while(Macros[i] != "") {
    CurrentMacro = Macros[i++];
    // Load the macro
    TPhDetector::DeleteInstance();
    gROOT->LoadMacro(CurrentMacro);
    strcpy(Line, CurrentMacro);
    j = strlen(CurrentMacro) - 1;
    Line[j--] = ')';
    Line[j] = '(';

    ret_string = gROOT->ProcessLineFast(Line);
    // Write the status out to our results file
    if(!ret_string)
      sprintf(ShellCmd, "echo \"%s: OK\" >> BenchResult.out", CurrentMacro);
    else {
      sprintf(ShellCmd, "echo \"%s: %s\" >> BenchResult.out", CurrentMacro,
	      ret_string);
      BadBehavior++;
    }
    gSystem->Exec(ShellCmd);
  }
  // This one liner indicates that we got through all the benchmarks
  // We never get here if crashes happened before hand
  if(BadBehavior == 0)
    gSystem->Exec("echo \"WONDERFUL...\" >> BenchResult.out");
  else
    gSystem->Exec("echo \"PhAT is BAD!\" >> BenchResult.out");
}
