// Simple 3D event display of a randomly generated event.
//
//Begin_Html <A HREF="mailto:decowski@mit.edu">decowski@mit.edu</A>
//End_Html
{
    gROOT->Reset();

    TPhHit    *hit;
    TPhEvent  *event;

    TObjArray *HitList;
    TObjArray *TrackList;
    TPhTrack  *track;

    // Get the detector object. This is only needed by TPhSwim, to trace the 
    // tracks through the detector
    Char_t FileName[256];
    sprintf(FileName,"%s/init/test/Detector.root", 
	    gSystem->Getenv("PHATHOME"));
    TFile f(FileName);
    // Get version 3.8
    TPhDetector *det = f.Get("PMC_V4.20");
    f.Close();

    // Draw the Canvas
    TCanvas c2("view");
    TView v(1);
    v.SetRange(-5, -5, -5, 80, 20, 80);

    // TPhSwim also needs a magnet object.
    TPhIdealMagnet *magnet = new TPhIdealMagnet();

    // Instantiate TPhSwim and connect the detector and magnet objects to it.
    TPhSwim *swim  = new TPhSwim();
    swim->SetDetector(det);
    swim->SetMagnet(magnet);

    // Create a TPhRandomEvent object
    TPhRandomEvent *random = new TPhRandomEvent();
    // Set the charged particle mulitplicity
    random->SetMult(8000);

    event = random->GetNextEvent();
    printf("Swimming the event will take a while! ~30s\n");
    swim->SwimEvent(event);

    // draw detector 
    det->Draw();

    TPhSensor *sensor;
    TPhHit *hit;
    TObjArray *hitlist;
       
    // Iterate over all Layers, Sensors, down to hits and draw them
    TIter NextSensor(det->GetSensorList());
    while(sensor = (TPhSensor *) NextSensor()) {
      hitlist = (TObjArray *)sensor->GetHitList();
      if (hitlist) {
	TIter NextHit(hitlist);
	while(hit = (TPhHit *) NextHit())
	  hit->Draw();
      }
    }

    // Iterate over all tracks and draw them.
    TPhObjectContainer *tracks;
    tracks = (TPhObjectContainer*) event->GetObject("MCTracks");
    TIter TrackIter(tracks->GetObjectList());
    TPhTrack *track;
    while(track = (TPhTrack*) TrackIter())
      track->Draw();
}




