{
    gROOT->Reset();
   
    Float_t x;
    Float_t z;
    Int_t num = 0;
    Int_t i;

    TH2F h2("h2","hits vs theta",100,0,3.14,20,0,20);
    TH2F x_z("x_z","x_z",500,0,80,500,0,80);
    TCanvas c("C");
    TPhEvent *event;
    TPhHit   *hit;  

    TPhSwim   *swim = new TPhSwim();
    TPhMagnet *magnet = new TPhIdealMagnet();
    TPhDetector *det = new TPhDetector();

    const Char_t *phathome = gSystem->Getenv("PHATHOME");
    printf("Found PHAT home at %s\n",phathome);

    Char_t pathname[256];
    sprintf(pathname,"%s/init/test.2d", phathome);
    det->ReadASCIIGeometry(pathname);

    swim->SetMagnet(magnet);
    swim->SetDetector(det);
    swim->SetMS(0);

    event = new TPhEvent();
    Float_t oopmin = 10;
    Float_t oopmax = 0.2;
    Float_t oopstep = (oopmin - oopmax)/200;
    Float_t p;
    Float_t px;
    Float_t pz;
    Float_t oop = oopmin;

    for(i=0;i<1000;i++)
    {
        track = new TPhTrack();
        track->SetPx(gRandom->Rndm());
        track->SetPz(gRandom->Rndm());
        track->SetPy(0);
        track->SetMass(0.139);
        if(gRandom->Rndm() > 0.5)
            track->SetCharge(1);
        else
            track->SetCharge(1);
    
        swim->SetVerbose(0);
        swim->SwimTrack(track);
    
        track->ResetHitCounter();
        while(hit = track->GetNextHit())
        {
            x_z.Fill(hit->GetZ(),hit->GetX(),hit->GetPlane());
        }
    }
    x_z.Draw("lego");
    c.Update();
}
