{
    gROOT->Reset();
    gROOT->Time();



    Float_t x;
    Float_t z;
    Float_t dist;
    Int_t num = 0;
    Int_t i;
   
    Float_t chi2;
    Float_t ndof;
    Float_t p;
    
    const Float_t kMinOop = 1;
    const Float_t kMaxOop = 8;
    const Float_t kOopStep = (kMaxOop - kMinOop)/10;

    TPhHit *hit;
    TPhStuff *stuff = new TPhStuff();

// For some of the later stuff we will need to know the 
// location of the $PHATHOME directory. Use the TSystem 
// class (thanks, Fons) for getting this variable:

   const Char_t *phathome = gSystem->Getenv("PHATHOME");
   printf("Found PHAT home at %s\n",phathome);
   Char_t fname[256];

    printf("Create Magnet\n");

    TPhIdealMagnet *magnet = new TPhIdealMagnet();

    printf("Create Detector\n");

    TPhDetector *det  = new TPhDetector();
    sprintf(fname,"%s/init/test",phathome);
    det->ReadASCIIGeometry(fname);

    printf("Create Simulator\n");

    TPhSwim   *swim = new TPhSwim();
    swim->SetMagnet(magnet);
    swim->SetDetector(det);
    swim->SetMS(kFALSE);
    swim->SetPixelize(kFALSE);
    swim->SetVerbose(kFALSE);

    TObjArray *TemplateList = new TObjArray();

    printf("Create templates between %g %g, %g stepsize\n",kMinOop,kMaxOop,kOopStep);

    Float_t p;
    Float_t px;
    Float_t py;
    Float_t pz;
    Float_t oop;
    Float_t vec[13];
    Int_t cnt;

    det->Draw();


    for(oop=kMinOop;oop<kMaxOop;oop+=kOopStep)
    {
        p = 1/oop;
        px = p/sqrt(2);
        pz = p/sqrt(2);
        py = 0;

        TrueTrack = new TPhTrack();
        TrueTrack->SetPx(px);
        TrueTrack->SetPy(py);
        TrueTrack->SetPz(pz);
        TrueTrack->SetMass(0.139);
        TrueTrack->SetCharge(1);
        swim->SwimTrack(TrueTrack);
        TrueTrack->Draw(4);

        swim->SetMS(kTRUE);
        swim->SetPixelize(kTRUE);
        swim->SetVerbose(0);      
    
    
// First, fill tracks with multiple scattering into the track
// template to determine average distance from the template
// in each plane. 
// The full covariance matrix is then filled in the next step
// with the normalized errors. That's done to make the inter-
// polation of missing rows easier.

        for(i=0;i<1500;i++)
        {
            if(!(i%100))
            {
                printf("Add track %d\n",i);
            }
            track = new TPhTrack();
            track->SetPx(px);
            track->SetPy(py);
            track->SetPz(pz);
            track->SetMass(0.139);
            track->SetCharge(1);
            swim->SwimTrack(track);
            delete track;
            det->DeleteHits();
        }
    }
}


