// A.O.
// Read events from a Root file and translate the RawHitBuffers back into 
// HitArrays. The new HitArrays are put into a "BackHitArrays" container. 
// These could then be compared to for instance the HitArrays in "MCHitArrays"

//back() 
{
    gROOT->Reset();

    Int_t      i,j;

    TObjArray        *CList;
    TObjArray        *OList;

    TPhMCTrack       *track;
    TPhMCHit         *hit;
    TPhHitArray      *hitarray;
    TPhRawHitBuffer  *rhitbuffer;
    TPhObjectContainer *DContainer;
    TPhEvent         *event;


    // Open the data file. File can be generated by the write_events.C macro
    // As with all Phat stuff, PHATHOME envrionment has to be defined and 
    // pointing to the main Phat directory
    Char_t *inputn = "pmc100ev89.hijet.aou.root";
    Char_t FileName[200];
    sprintf(FileName, "%s/data/%s", gSystem->Getenv("PHATHOME"),inputn);
    TPhDST *dst = new TPhDST(FileName);

    // get input TFile to read geometry in
    TFile *f = dst->GetFile(); 
    TPhDetector *detector = TPhDetector::GetInstance(); 
    TPhTranslate *t;
    if( !detector ) {
       detector = (TPhDetector *) f->Get("PMC_V3.80");
       t = detector->MakeTranslateObject();
    }
    // Open the output file. 
    sprintf(FileName, "%s/data/%s.back", gSystem->Getenv("PHATHOME"),inputn);
    TFile *fo = new TFile(FileName,"RECREATE");

    //  Lets read only one event //
    while( event = dst->GetNextEvent()) 
    {
      //      event = dst->GetNextEvent();
      detector->SetEvent(event);
      detector->MakeHitArrays("MCRawHitBuffers","BackHitArrays");

      printf("Found %d %d \n",event->GetNRun(), event->GetNEvent());
      fo.cd();
      event->ls("C");
      event->Write();

      delete event;
    }
    dst->Close();
    fo->Close();
}
