//  macro that reads Test Beam 98 data and produces TPhEvents with 
//  RawHitFECn0 objects, and more. This macro uses TPhBT98DST data manager
//  with compiled methods for reading data from file.
//  It produces histograms of means and rms's for pedestal file.
main (Char_t *inputfilename=0, Int_t runno=0)
{
  gROOT->Reset();

  //  inputfilename = "ped005.dat";

  const Int_t kMaxEvents = 10000;
  Int_t skipevents = 0;
  Int_t runno = 0;
  Int_t verbose = 1;

  // Histogram booking
  TH2D *histA00ADC = new TH2D("A00","Plane NA00 - ADCs",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histA01ADC = new TH2D("A01","Plane NA01 - ADCs",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histB00ADC = new TH2D("B00","Plane NB00 - ADCs",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histB01ADC = new TH2D("B01","Plane NB01 - ADCs",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histC00ADC = new TH2D("C00","Plane NC00 - ADCs",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histC01ADC = new TH2D("C01","Plane NC01 - ADCs",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histD00ADC = new TH2D("D00","Plane ND00 - ADCs",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histD01ADC = new TH2D("D01","Plane ND01 - ADCs",70, -0.5, 69.5, 22, -0.5, 21.5);

  histA00ADC->Sumw2();
  histA01ADC->Sumw2();
  histB00ADC->Sumw2();
  histB01ADC->Sumw2();
  histC00ADC->Sumw2();
  histC01ADC->Sumw2();
  histD00ADC->Sumw2();
  histD01ADC->Sumw2();

  TH2D *histA00mADC = new TH2D("A00m","Plane NA00 - ADC means",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histA01mADC = new TH2D("A01m","Plane NA01 - ADC means",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histB00mADC = new TH2D("B00m","Plane NB00 - ADC means",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histB01mADC = new TH2D("B01m","Plane NB01 - ADC means",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histC00mADC = new TH2D("C00m","Plane NC00 - ADC means",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histC01mADC = new TH2D("C01m","Plane NC01 - ADC means",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histD00mADC = new TH2D("D00m","Plane ND00 - ADC means",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histD01mADC = new TH2D("D01m","Plane ND01 - ADC means",70, -0.5, 69.5, 22, -0.5, 21.5);

  TH2D *histA00vADC = new TH2D("A00v","Plane NA00 - ADC sigmas",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histA01vADC = new TH2D("A01v","Plane NA01 - ADC sigmas",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histB00vADC = new TH2D("B00v","Plane NB00 - ADC sigmas",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histB01vADC = new TH2D("B01v","Plane NB01 - ADC sigmas",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histC00vADC = new TH2D("C00v","Plane NC00 - ADC sigmas",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histC01vADC = new TH2D("C01v","Plane NC01 - ADC sigmas",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histD00vADC = new TH2D("D00v","Plane ND00 - ADC sigmas",70, -0.5, 69.5, 22, -0.5, 21.5);
  TH2D *histD01vADC = new TH2D("D01v","Plane ND01 - ADC sigmas",70, -0.5, 69.5, 22, -0.5, 21.5);

  Char_t *ctitle[100];
  sprintf(ctitle,"NA00 ADC histogram for file %s",inputfilename);
  TCanvas *c1 = new TCanvas("c1",ctitle,10,10,800,500);
  c1->Divide(2,1);
  c1->cd(1);
  histA00mADC->Draw("lego");
  gPad->SetPhi(-45);
  c1->cd(2);
  histA00vADC->Draw("lego");
  gPad->SetPhi(-45);

  sprintf(ctitle,"NA01 ADC histogram for file %s",inputfilename);
  TCanvas *c2 = new TCanvas("c2",ctitle,10,10,800,500);
  c2->Divide(2,1);
  c2->cd(1);
  histA01mADC->Draw("lego");
  gPad->SetPhi(-45);
  c2->cd(2);
  histA01vADC->Draw("lego");
  gPad->SetPhi(-45);

  sprintf(ctitle,"NB00 ADC histogram for file %s",inputfilename);
  TCanvas *c3 = new TCanvas("c3",ctitle,10,10,800,500);
  c3->Divide(2,1);
  c3->cd(1);
  histB00mADC->Draw("lego");
  gPad->SetPhi(-45);
  c3->cd(2);
  histB00vADC->Draw("lego");
  gPad->SetPhi(-45);

  sprintf(ctitle,"NB01 ADC histogram for file %s",inputfilename);
  TCanvas *c4 = new TCanvas("c4",ctitle,10,10,800,500);
  c4->Divide(2,1);
  c4->cd(1);
  histB01mADC->Draw("lego");
  gPad->SetPhi(-45);
  c4->cd(2);
  histB01vADC->Draw("lego");
  gPad->SetPhi(-45);

  sprintf(ctitle,"NC00 ADC histogram for file %s",inputfilename);
  TCanvas *c5 = new TCanvas("c5",ctitle,10,10,800,500);
  c5->Divide(2,1);
  c5->cd(1);
  histC00mADC->Draw("lego");
  gPad->SetPhi(-45);
  c5->cd(2);
  histC00vADC->Draw("lego");
  gPad->SetPhi(-45);

  sprintf(ctitle,"NC01 ADC histogram for file %s",inputfilename);
  TCanvas *c6 = new TCanvas("c6",ctitle,10,10,800,500);
  c6->Divide(2,1);
  c6->cd(1);
  histC01mADC->Draw("lego");
  gPad->SetPhi(-45);
  c6->cd(2);
  histC01vADC->Draw("lego");
  gPad->SetPhi(-45);

  sprintf(ctitle,"ND00 ADC histogram for file %s",inputfilename);
  TCanvas *c7 = new TCanvas("c7",ctitle,10,10,800,500);
  c7->Divide(2,1);
  c7->cd(1);
  histD00mADC->Draw("lego");
  gPad->SetPhi(-45);
  c7->cd(2);
  histD00vADC->Draw("lego");
  gPad->SetPhi(-45);

  sprintf(ctitle,"ND01 ADC histogram for file %s",inputfilename);
  TCanvas *c8 = new TCanvas("c8",ctitle,10,10,800,500);
  c8->Divide(2,1);
  c8->cd(1);
  histD01mADC->Draw("lego");
  gPad->SetPhi(-45);
  c8->cd(2);
  histD01vADC->Draw("lego");
  gPad->SetPhi(-45);

  // INPUT file
  //-----------
  if(!inputfilename) {
     printf("Call main(filename) with the input file name as a parameter\n");
     return;
  }
  TPhBT98DST *bt = NULL;
  bt = new TPhBT98DST(inputfilename,skipevents,runno);
  bt->SetVerbose(verbose);
  if( !bt->IsInitialized() ) return;

  // OUTPUT file
  //------------
  Char_t outputfilename[100];
  sprintf(outputfilename,"%s.root",inputfilename);
  printf("Converting TB98 file %s to %s ROOT format\n",inputfilename,outputfilename);
  TFile *outputfile;
  if(!(outputfile = new TFile(outputfilename,"RECREATE","Test Beam 98 data"))) {
     printf("Error: Output file %s could not be opened.\n",outputfilename);
     return;
  }

  // Get TB98 detector
  //------------------
  const Char_t *phathome = gSystem->Getenv("PHATHOME");
  Char_t *detpath[100];
  sprintf(detpath,"%s/init/Detector_TB98.root",phathome);
  TFile *detfile = new TFile(detpath);
  TPhDetector *detector = detfile->Get("PMC_TB98_V4.30");
  
  // prepare for conversion and read the raw byte stream from TB98 data file
  Int_t xpix=0,ypix=0,adc=0,eventcounter=0;
  TPhSiSensor *plane=NULL;
  TPhHitArray *ha=NULL;
  TPhEvent *event = NULL;
  TPhObjectContainer *rawcont = NULL;
  
  outputfile->cd();
  while( (event = bt->GetNextEvent()) ) {
    eventcounter++;
    // actions on the event_by_event basis
    //---------------------------------------
    detector->SetEvent(event);
    detector->MakeHitArrays("RawHitFECn0s","HitArraysTB98");
    detector->FillWithEventHitArrays("HitArraysTB98");
    plane = (TPhSiSensor *) detector->GetSensor("NA00");
    ha = plane->GetHitArray();
    //NA00
    for(xpix=0;xpix<70;xpix++) {
      for(ypix=0;ypix<22;ypix++) {
	adc = ha->GetADC(ypix,xpix);
	//DEBUG
	//             printf("XPIX: %5d YPIX: %5d ADC: %6d\n",xpix,ybix,adc);
	//DEBUG
	histA00ADC->Fill(xpix,ypix,adc);
      }
    }
    //NA01
    ha = ((TPhSiSensor *) detector->GetSensor("NA01"))->GetHitArray();
    for(xpix=0;xpix<70;xpix++) {
      for(ypix=0;ypix<22;ypix++) {
	adc = ha->GetADC(ypix,xpix);
	histA01ADC->Fill(xpix,ypix,adc);
      }
    }
    //NB00
    ha = ((TPhSiSensor *) detector->GetSensor("NB00"))->GetHitArray();
    for(xpix=0;xpix<70;xpix++) {
      for(ypix=0;ypix<22;ypix++) {
	adc = ha->GetADC(ypix,xpix);
	histB00ADC->Fill(xpix,ypix,adc);
      }
    }
    //NB01
    ha = ((TPhSiSensor *) detector->GetSensor("NB01"))->GetHitArray();
    for(xpix=0;xpix<70;xpix++) {
      for(ypix=0;ypix<22;ypix++) {
	adc = ha->GetADC(ypix,xpix);
	histB01ADC->Fill(xpix,ypix,adc);
      }
    }
    //NC00
    ha = ((TPhSiSensor *) detector->GetSensor("NC00"))->GetHitArray();
    for(xpix=0;xpix<70;xpix++) {
      for(ypix=0;ypix<22;ypix++) {
	adc = ha->GetADC(ypix,xpix);
	histC00ADC->Fill(xpix,ypix,adc);
      }
    }
    //NC01
    ha = ((TPhSiSensor *) detector->GetSensor("NC01"))->GetHitArray();
    for(xpix=0;xpix<70;xpix++) {
      for(ypix=0;ypix<22;ypix++) {
	adc = ha->GetADC(ypix,xpix);
	histC01ADC->Fill(xpix,ypix,adc);
      }
    }
    //ND00
    ha = ((TPhSiSensor *) detector->GetSensor("ND00"))->GetHitArray();
    for(xpix=0;xpix<70;xpix++) {
      for(ypix=0;ypix<22;ypix++) {
	adc = ha->GetADC(ypix,xpix);
	histD00ADC->Fill(xpix,ypix,adc);
      }
    }
    //ND01
    ha = ((TPhSiSensor *) detector->GetSensor("ND01"))->GetHitArray();
    for(xpix=0;xpix<70;xpix++) {
      for(ypix=0;ypix<22;ypix++) {
	adc = ha->GetADC(ypix,xpix);
	histD01ADC->Fill(xpix,ypix,adc);
      }
    }
    //---------------------------------------
    outputfile->cd();
    event->Write();
    delete event;
    if(eventcounter >= kMaxEvents) break;
  }

  // retrieve means and variances and put them into 2d histos for display
  Int_t xbin,ybin;
  Double_t mean,w2,var;
  Char_t dummy[2];
  for(xbin=1;xbin<71;xbin++) {
    for(ybin=1;ybin<23;ybin++) { 
      //NA00
      mean = histA00ADC->GetCellContent(xbin,ybin)/eventcounter;
      w2 = (histA00ADC->GetCellError(xbin,ybin))**2/eventcounter;
      var = sqrt(w2-mean*mean);
      histA00mADC->SetCellContent(xbin,ybin,mean);
      histA00mADC->SetCellError(xbin,ybin,var/sqrt(eventcounter));
      histA00vADC->SetCellContent(xbin,ybin,var);
      //      printf("%d %d %d %f %f %f\n",xbin,ybin,eventcounter,mean,w2,var);
      //      gets(dummy);

      //NA01
      mean = histA01ADC->GetCellContent(xbin,ybin)/eventcounter;
      w2 = (histA01ADC->GetCellError(xbin,ybin))**2/eventcounter;
      var = sqrt(w2-mean*mean);
      histA01mADC->SetCellContent(xbin,ybin,mean);
      histA01mADC->SetCellError(xbin,ybin,var/sqrt(eventcounter));
      histA01vADC->SetCellContent(xbin,ybin,var);

      //NB00
      mean = histB00ADC->GetCellContent(xbin,ybin)/eventcounter;
      w2 = (histB00ADC->GetCellError(xbin,ybin))**2/eventcounter;
      var = sqrt(w2-mean*mean);
      histB00mADC->SetCellContent(xbin,ybin,mean);
      histB00mADC->SetCellError(xbin,ybin,var/sqrt(eventcounter));
      histB00vADC->SetCellContent(xbin,ybin,var);

      //NB01
      mean = histB01ADC->GetCellContent(xbin,ybin)/eventcounter;
      w2 = (histB01ADC->GetCellError(xbin,ybin))**2/eventcounter;
      var = sqrt(w2-mean*mean);
      histB01mADC->SetCellContent(xbin,ybin,mean);
      histB01mADC->SetCellError(xbin,ybin,var/sqrt(eventcounter));
      histB01vADC->SetCellContent(xbin,ybin,var);

      //NC00
      mean = histC00ADC->GetCellContent(xbin,ybin)/eventcounter;
      w2 = (histC00ADC->GetCellError(xbin,ybin))**2/eventcounter;
      var = sqrt(w2-mean*mean);
      histC00mADC->SetCellContent(xbin,ybin,mean);
      histC00mADC->SetCellError(xbin,ybin,var/sqrt(eventcounter));
      histC00vADC->SetCellContent(xbin,ybin,var);

      //NC01
      mean = histC01ADC->GetCellContent(xbin,ybin)/eventcounter;
      w2 = (histC01ADC->GetCellError(xbin,ybin))**2/eventcounter;
      var = sqrt(w2-mean*mean);
      histC01mADC->SetCellContent(xbin,ybin,mean);
      histC01mADC->SetCellError(xbin,ybin,var/sqrt(eventcounter));
      histC01vADC->SetCellContent(xbin,ybin,var);

      //ND00
      mean = histD00ADC->GetCellContent(xbin,ybin)/eventcounter;
      w2 = (histD00ADC->GetCellError(xbin,ybin))**2/eventcounter;
      var = sqrt(w2-mean*mean);
      histD00mADC->SetCellContent(xbin,ybin,mean);
      histD00mADC->SetCellError(xbin,ybin,var/sqrt(eventcounter));
      histD00vADC->SetCellContent(xbin,ybin,var);

      //ND01
      mean = histD01ADC->GetCellContent(xbin,ybin)/eventcounter;
      w2 = (histD01ADC->GetCellError(xbin,ybin))**2/eventcounter;
      var = sqrt(w2-mean*mean);
      histD01mADC->SetCellContent(xbin,ybin,mean);
      histD01mADC->SetCellError(xbin,ybin,var/sqrt(eventcounter));
      histD01vADC->SetCellContent(xbin,ybin,var);
    }
  }
  // display means and variances
  c1->Update();
  c2->Update();
  c3->Update();
  c4->Update();
  c5->Update();
  c6->Update();
  c7->Update();
  c8->Update();

  outputfile->cd();
  // write down averages and variances
  histA00mADC->Write();
  histA01mADC->Write();
  histB00mADC->Write();
  histB01mADC->Write();
  histC00mADC->Write();
  histC01mADC->Write();
  histD00mADC->Write();
  histD01mADC->Write();
  histA00vADC->Write();
  histA01vADC->Write();
  histB00vADC->Write();
  histB01vADC->Write();
  histC00vADC->Write();
  histC01vADC->Write();
  histD00vADC->Write();
  histD01vADC->Write();
  
  bt->Close(); 
  outputfile->Close();
}
