// Made by A.O. on 4.11.1997
// Read events from a root file and show some info about the events.
// Custom example of general listing of event data containers and data objects
//main() 
{
    gROOT->Reset();

    Int_t      i,j;

    TObject          *object,*object1;
    TPhDataObject    *dataobject;
    TPhObjectContainer *DContainer;
    TObjArray        *CList;

    TPhEvent         *event;


    // Open the data file. File can be generated by the write_events.C macro
    // As with all Phat stuff, PHATHOME envrionment has to be defined and 
    // pointing to the main Phat directory
    Char_t FileName[200];
    sprintf(FileName, "%s/data/pmc100ev89.hijet.aou.root.gufldswum", gSystem->Getenv("PHATHOME"));
    TPhDST *dst = new TPhDST(FileName);

    //    while( event = dst->GetNextEvent()) 
    {
    //  read only one event now to avoid text overflow on the screen
      event = dst->GetNextEvent();
      printf("Found event %d %d \n",event->GetNRun(), event->GetNEvent());

      THashTable *objlist = event->GetObjectList();
      Int_t noobjects = objlist->GetSize();
      TIter ObjIter(objlist);
      while(object = ObjIter()) {
        DContainer = NULL;
        CList = NULL;
	// we can have either TPhObjectContainer or a TPhDataObject in the event's 
	// object list and we need to act differently depending on what is there.
        if( object->IsA() == TPhObjectContainer::Class()) {
          DContainer = (TPhObjectContainer *) object;
          if( !DContainer ) {
             printf("\n!!! NULL DContainer pointer. !!!\n");
             continue;
          } else {
             CList = DContainer->GetObjectList();
             Char_t *name = DContainer->GetName();
          }
          if( CList ) {
             printf("\n>>%s<< data container found: %d data objects in this container\n", 
                     name, CList->GetEntries());
             object1 = NULL;
             TIter ObjIter1(CList);
             while(object1 = ObjIter1()) {
                object1->Execute( "Print","");
	        gSystem->Sleep(100);
             }
          }
          continue;
	}
        if( object->IsA() == TPhDataObject::Class()) {
           dataobject = (TPhDataObject *) object;
           Char_t *name = dataobject->GetName();
           printf("\n>>%s<< data object found in the event list\n", name);
           object->Execute( "Print","" );
           continue;
	}
        printf("\nUnknown TObject of class %s found in the list of event objects.\n", 
                  object->IsA()->GetName());
      }
    }
}
