// Test of Online display. Draws histograms of the deposited energies in
// the various detectectors. 
//
// $Id: checkon.C,v 1.5 1999/02/12 15:51:49 katzy Exp $
Char_t* checkon()
{

  Char_t FileName[200];
  sprintf(FileName, "$PHATHOME/data/hijing_2cen.adat.root"); 
  TPhDST *dst = new TPhDST(FileName);

  if(!dst->GetFile()->IsOpen())
    return "Couldn't open file %s!\n";

  TPhDetector *det = dst.GetDetector();
  if(!det)
    return "Couldn't get detector!\n";
  TPhEvent *event;
  Int_t n=0;
  TPhOnSensorContainer *sensorhistos = new TPhOnSensorContainer("Sensors");
  sensorhistos->Init();
  TObjArray *arr = sensorhistos->GetOnArray();
  printf("array entries = %d\n",arr->GetEntries());
  TPhOnSensor *onsens;
  while (event = dst->GetNextEvent() && n<10) {

    det->SetEvent(event);
    det->FillWithEventHitArrays("PMCHitArraysFromHits");
    n++;
    sensorhistos->Fill();
    delete event;
  }
  onsens = (TPhOnSensor*) arr->At(11);
  TH1S *hh = onsens->GetHistogram("adc");
  //  hh->Draw();
  printf("histogram entries %d\n",hh->GetEntries());
  // this check only make sense for many events (each sensor has to be hit 
  // at least once)
  //  if(!sensorhistos->Check()) 
  //  printf("WARNING - THERE ARE EMPTY HISTOGRAMS \n");
  // check correct filling in octagon - since occupancy is higher here
  if(!sensorhistos->Check("MOB1","adc")) 
   return "ERROR - HISTOGRAMS not FILLED\n";


// test saving histograms on file in current directory
  TFile f("checkon.root","RECREATE");
  sensorhistos->Write();
  f.Close();

  // read histos from file
  TFile fin("checkon.root");
  TPhOnSensorContainer *sh = (TPhOnSensorContainer*)fin.Get("Sensors");
  sh->Draw("MOB1");
  fin.Close();

  return NULL;
}








