#include "matrix.h"

ClassImp(matrix)

//////////////////////////////////////////////////////////////////////////////////////////
//
// matrix is a class stolen from some public domain software and it is only used to 
// store the covariant matrix for the Tracktemplates. It should probably be exchanged for 
// the TMatrix class that is now available in Root. 
//
//////////////////////////////////////////////////////////////////////////////////////////

matrix::matrix(void)
{
	this->row = this->col = 0;
	this->mat = NULL;

	#ifdef __DEBUG__
	cerr<<"my no initialization constructor\n";
	#endif
}

matrix::matrix(UInt_t x, UInt_t y)
{
	#ifdef __RUN_TIME_CHECKING__
	if(!(x > 0 && y > 0)){
		cerr << "invalid matrix size\n";
		exit(1);
	}
	#endif

	this->mat = new Double_t[(this->row=x)*(this->col=y)];
	#ifdef __DEBUG__
	cerr<<"regular constructor\n";
	#endif
}

matrix::matrix(UInt_t x, UInt_t y, enum mat_type type)
{
	UInt_t i, j, k, l;

	#ifdef __RUN_TIME_CHECKING__
	if(!(x > 0 && y > 0)){
		cerr << "invalid matrix size\n";
		exit(1);
	}

	if(x!=y){
		cerr << "invalid matrix size: an identity matrix must be square\n";
		exit(1);
	}
	#endif

	k = this->row=x;
	l = this->col=y;

	this->mat = new Double_t[k*l];
	for(i=0;i<k;i++)
		for(j=0;j<l;j++) 
		{
			this->poke(i,j, 0.0);
			if(type==identity && i==j) this->poke(i,j, 1.0);
		}

	#ifdef __DEBUG__
	cerr<<"unity constructor\n";
	#endif
}

matrix::matrix(UInt_t x, UInt_t y, Double_t init)
{
	UInt_t i, j, k, l;

	#ifdef __RUN_TIME_CHECKING__
	if(!(x > 0 && y > 0)){
		cerr << "invalid matrix size\n";
		exit(1);
	}
	#endif

	k = this->row=x;
	l = this->col=y;

	this->mat = new Double_t[k*l];
	for(i=0;i<k;i++) for(j=0;j<l;j++) this->poke(i,j, init);

	#ifdef __DEBUG__
	cerr<<"initialize constructor\n";
	#endif
}

matrix::~matrix(void)
{
	delete[] this->mat;
	this->row = this->col = 0;

	#ifdef __DEBUG__
	cerr<<"destructor\n";
	#endif
}

matrix::matrix(const matrix & m) // copy constructor
{
	UInt_t i, k;

	this->mat = new Double_t[k=(this->row=m.row)*(this->col=m.col)];
	for(i=0;i<k;i++) this->mat[i] = m.mat[i];

	#ifdef __DEBUG__
	cerr<<"copy constructor\n";
	#endif
}
