#include "matrix.h"

Double_t matrix::det() const
{
	#ifdef __RUN_TIME_CHECKING__ 
	if(this->rowlen() != this->collen()){
		cerr << "invalid matrix size: determinant on non-square matrix\n";
		exit(1);
	}
	#endif

	Int_t i;
	UInt_t j;
	Double_t result;
	UInt_t n = this->rowlen();
	matrix P;
	matrix A = this->lu(i, P);

	switch (i)
    {
    	// singular
		case -1:
			result = 0.0;
			break;

		// normal case: |A| = |L||U||P|
		// |L| = 1,
		// |U| = multiplication of the diagonal
		// |P| = +-1
		default:
			result = 1.0;
			for (j = 0; j < n ; j++)
				result *= A.peek((UInt_t)P.peek(j,0),j);
			result *= (i % 2 ? -1 : 1);
			break;
    }
	return (result);
}
