#ifndef _TPhDataObject_INCLUDED_
#define _TPhDataObject_INCLUDED_

///////////////////////////////////////////////////////////////////////
//                                                                   //
//    TPhDataObject                                                  //
//                                                                   //
//    Phobos data storage class.                                     //
//                                                                   //
//    Author  : Gunther Roland (gunter.roland@cern.ch)               //
//    Created : July 13 1997                                         //
//    Version : 1.0                                                  //
//    Changed :                                                      //
//                                                                   //
///////////////////////////////////////////////////////////////////////

// Root Classes

#include "TNamed.h"
#include "time.h"

// PHOBOS Classes

#include "TPhCreationID.h"

class TPhDataObject : public TNamed {

public:

    TPhDataObject();
    TPhDataObject(Char_t *Name,Char_t *Title = NULL);
    
    virtual ~TPhDataObject();

    virtual TPhCreationID *GetCreationID()  { return fCreationID; }
    virtual Bool_t         IsPersistent()   { return fIsPersistent; }

    virtual void           SetCreationID(TObject *Creator);
    virtual void           SetPersistent(Bool_t b)  { fIsPersistent = b; }

    virtual void           ls(Option_t *option = "");
    virtual void           Print(Option_t *option = "99");

private:

    TPhCreationID *fCreationID;   // Globally unique ID specifying creation details
    Bool_t         fIsPersistent; // Flag marking object as persistent 

public:

    ClassDef(TPhDataObject,1)    // PHOBOS data container class

};

#endif




