#ifndef _PhMCHit_INCLUDED_
#define _PhMCHit_INCLUDED_

///////////////////////////////////////////////////////////////////////
//                                                                   //
//    TPhMCHit                                                       //
//                                                                   //
//    Author  : Andrzej Olszewski                                    //
//    Created : 01/16/96                                             //
//    Version : 1.0                                                  //
//    Changed : 11.11.1998  Andrzej Olszewski & Krzysztof Wozniak    //
//                                                                   //
///////////////////////////////////////////////////////////////////////

// Root Classes

#include "TObject.h"

#include <string.h>

// Phobos Classes
#include "TPhHit.h"

class TPhMCHit : public TPhHit {

public:
    TPhMCHit(); 
    
    virtual ~TPhMCHit() { }

    virtual Float_t  GetDx()           { return fDx;         }
    virtual Float_t  GetDy()           { return fDy;         }
    virtual Float_t  GetDz()           { return fDz;         }
    virtual Int_t    GetTrackNo()      { return fTrackNo;    }
    virtual Float_t  GetPsi()          { return fPsi;        }
    virtual Float_t  CalcPsi();
    virtual Float_t  GetLength()       { return fLength;     } 
    virtual Float_t  CalcDLength();

    virtual void     SetDx(Float_t x)       { fDx = x;            }
    virtual void     SetDy(Float_t x)       { fDy = x;            }
    virtual void     SetDz(Float_t x)       { fDz = x;            }
    virtual void     SetTrackNo(Int_t n)    { fTrackNo = n;       }
    virtual void     SetPsi(Float_t x)      { fPsi = x;           }
    virtual void     SetLength(Float_t x)   { fLength = x;        }

    virtual void     Print(Option_t *option = "");
    virtual void     ls(Option_t *option = "");

protected:

    Float_t      fDx;            // Vector from the entrance                
    Float_t      fDy;            //  to the exit                
    Float_t      fDz;            //  from the sensor               
    Int_t        fTrackNo;       // MC track number (from Geant)
    Float_t      fPsi;           // track angle at the sensor:
                                 //  can be calculated from fDx and fDz
    Float_t      fLength;        // Length of the track up to the sensor hit

public:

    ClassDef(TPhMCHit,2)  // PHOBOS Monte Carlo hit data class

};

#endif




