#ifndef _PhMCTrack_INCLUDED_
#define _PhMCTrack_INCLUDED_

///////////////////////////////////////////////////////////////////////
//                                                                   //
//    TPhMCTrack                                                     //
//                                                                   //
//    Author  : Andrzej Olszewski                                    //
//    Created : 30.09.97                                             //
//    Version : 1.0                                                  //
//    Changed : 11.11.1998  Andrzej Olszewski & Krzysztof Wozniak    //
//                                                                   //
///////////////////////////////////////////////////////////////////////

// Root Classes

// Phobos Classes

#include "TPhTrack.h"
#include "TPhMomentumVector.h"


class TPhMCTrack : public TPhTrack {

public:

    TPhMCTrack() { }

    virtual ~TPhMCTrack() { } 

    virtual Char_t    *GetOriginName()            { return fOriginName;    }
    virtual Int_t      GetTrackNo()               { return fTrackNo;       }
    virtual Int_t      GetParentNo()              { return fParentNo;      }
    virtual Int_t      GetIStop()                 { return fIStop;         }

    virtual void       SetOriginName(Char_t *orig)    { strcpy(fOriginName, orig); }
    virtual void       SetTrackNo(Int_t n)        { fTrackNo = n;          }
    virtual void       SetParentNo(Int_t n)       { fParentNo = n;         }
    virtual void       SetIStop(Int_t n)          { fIStop = n;            }

    virtual void       ls(Option_t *option);
    virtual void       Print(Option_t *option);

protected:

    Char_t    fOriginName[10];      //  Name of the track's origin volume
    Int_t     fTrackNo;             //  Particle number from GEANT
    Int_t     fParentNo;            //  Number of the parent track (0 if primary)
    Int_t     fIStop;               //  Geant ISTOP flag for particles stoping or                                     //  decaying BUT ONLY INSIDE a sensor

public:
    ClassDef(TPhMCTrack,2) // PHOBOS MC track class

};

#endif

