#ifndef _TPhNoteManager_INCLUDED_
#define _TPhNoteManager_INCLUDED_

///////////////////////////////////////////////////////////////////////
//                                                                   //
//    TPhNoteManager                                                 //
//                                                                   //
//    Phobos class storing and managing a list of free text notes    //
//                                                                   //
//    TPhNoteManager keeps a list of TPhNotes objects, each with     //
//    its own name and title. TPhNotes object should be created      //
//    outside, filled with text notes and added by a call to         //
//    TPhNoteManager Add method. Using other methods One can list    //
//    the notes  names and titles and/or their content,              //
//    search the list for one of the notes by name and get its pointer/
//                                                                   //
//    Author  : Andrzej Olszewski (andrzej.olszewski@ifj.edu.pl)     //
//    Created : 02/12/98                                             //
//    Version : 1.0                                                  //
//    Changed :                                                      //
//                                                                   //
// $Id: TPhNoteManager.h,v 1.1 1998/12/09 08:15:39 olszewsk Exp $                                                              //
//                                                                   //
///////////////////////////////////////////////////////////////////////

// Root Classes
#include "TNamed.h"
#include "TList.h"

// Phat classes
#include "TPhNotes.h"

class TPhNoteManager : public TNamed {

public:

    TPhNoteManager();
    TPhNoteManager(Char_t *name, Char_t *title);

    virtual ~TPhNoteManager();

    void      AddNotes(TPhNotes *not);
    Int_t     GetNNotes();
    TPhNotes *GetNotes(Int_t pos);

    void      ls();
    void      Print();
    void      Print(Int_t pos);   
    void      Print(Char_t *name); 

private:

    TList    *fNotes;      //  list of TPhParKey parameter objects
    
public:

    ClassDef(TPhNoteManager,1)    // PHOBOS event header class

};

#endif




