#ifndef _TPhNotes_INCLUDED_
#define _TPhNotes_INCLUDED_

//////////////////////////////////////////////////////////////////////////
//                                                                      //
//    TPhNotes                                                          //
//                                                                      //
//    Phobos class for ROOT files notes                                 //
//                                                                      //
//    TPhNotes provides storage for notes that can be edited and        //
//    stored on a ROOT TFile file.                                      //
//                                                                      //
//                                                                      //
//    Author  : Andrzej Olszewski (andrzej.olszewski@ifj.edu.pl)        //
//    Created : 20/06/98                                                //
//    Version : 1.0                                                     //
//    Changed :                                                         //
//                                                                      //
// $Id: TPhNotes.h,v 1.2 1998/11/20 23:43:13 decowski Exp $
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "TNamed.h"
#include "TList.h"
#include "TObjString.h"

class TPhNotes : public TNamed {

  public: 
    TPhNotes();
    TPhNotes(Text_t *name, Text_t *title);
    virtual ~TPhNotes();  
  
    void  AddLine(Char_t *line);
    void  AddLineAt(Char_t *line, Int_t pos);

    const Char_t *GetFirstLine();
    const Char_t *GetNextLine();

    void    Print();

  private:
    TList *fLines;
    TObjString *fcurrLine;

  public:

    ClassDef(TPhNotes,1)  // PHOBOS root notes class
};

#endif

