#ifndef _PhRecTrack_INCLUDED_
#define _PhRecTrack_INCLUDED_

///////////////////////////////////////////////////////////////////////
//                                                                   //
//    TPhRecTrack                                                    //
//                                                                   //
//    Author  : Krzysztof Wozniak                                    //
//    Created : 16/01//96                                            //
//    Version : 1.0                                                  //
//                                                                   //
// $Id: TPhRecTrack.h,v 1.3 1999/01/09 22:18:38 wozniak Exp $ 
///////////////////////////////////////////////////////////////////////

// Root Classes

#include "TObject.h"
#include "TObjArray.h"
#include "TPolyLine3D.h"
#include "TClass.h"

// Phobos Classes

class TPhHit;
class TPhMomentumVector;
class TPhTrack;
class TPhStuff;


class TPhRecTrack : public TPhTrack {

public:

    TPhRecTrack()  {  }

    virtual ~TPhRecTrack()  {  }

    virtual void      SetStatus(Int_t n)  { fStatus = n;     }
    virtual void      SetChi2(Float_t x)  { fChi2 = x;       }
    virtual void      SetNDof(Float_t x)  { fNDof = x;       }
    virtual void      SetProb(Float_t x)  { fProb = x;       }
    virtual Float_t   CountProb(TPhStuff *stuff);

    virtual Int_t     GetStatus()         { return fStatus;     }
    virtual Float_t   GetChi2()           { return fChi2;       }
    virtual Float_t   GetNDof()           { return fNDof;       }
    virtual Float_t   GetProb()           { return fProb;       }

    virtual void       ls(Option_t *option);
    virtual void       Print(Option_t *option);

protected:
     
    Int_t       fStatus;       //  track status flag       
    Float_t     fChi2;         //  Chi-square of track fit
    Float_t     fNDof;         //  Number of degrees of freedom for fit
    Float_t     fProb;         //  Chi^2 probability (redundant)

public:
    ClassDef(TPhRecTrack,1) // PHOBOS reconstructed track class

};

#endif

