#include "TPhCreationID.h"

ClassImp(TPhCreationID)


////////////////////////////////////////////////////////////
//
// TPhCreationID is a bookkeeping class that stores some  
// key information about the creation of a TPhDataObject
//
////////////////////////////////////////////////////////////

TPhCreationID::TPhCreationID()
{
// Default constructor. Does nothing.
// Don't use this constructor unless you have to and know
// what you are doing
// Use TPhCreationID(TObject *Creator) instead.

}

TPhCreationID::TPhCreationID(TObject *Creator)
{
// Constructor. Fills the data members of the TPhCreationID
// based on the TObject pointer and some TSystem calls

   time(&fTime);
   Char_t HostName[512];
   if(!Creator)
   {
       fprintf(stderr, 
	       "Can't make TPhCreationID() for Creator = %p of type: %s\n",
	       Creator, Creator->IsA()->GetName());
   }
   else
   {
       TClass *cl = Creator->Class();
       fCreatorClassVersion = cl->GetClassVersion();
       fCreatorClassName    = new TNamed(cl->GetName(),"");
       fUserID = 0;
       sprintf(HostName,"%s",gSystem->HostName());
       fHost = new TInetAddress(gSystem->GetHostByName(&HostName[0]));
   }
}

TPhCreationID::~TPhCreationID()
{
// Destructor. Delete TPhCreationID 

   delete fHost;
   delete fCreatorClassName;
}

