#include "TPhHashContainer.h"
#include <iostream.h>

ClassImp(TPhHashContainer)


////////////////////////////////////////////////////////////
//
// TPhHashContainer is a PHOBOS data containing a hashed table
// of Data objects.
//
////////////////////////////////////////////////////////////

TPhHashContainer::TPhHashContainer()
{
// Defaults constructor. Does nothing.
// Don't use this constructor unless you have to and know
// what you are doing
// Use TPhHashContainer(Char_t *name) instead.

  fInitCap = 100;
  fReHash = 0;
  fHashTable = NULL;
}

TPhHashContainer::TPhHashContainer(Char_t *Name, Char_t *Title)
{
// Constructor. Create the hash table container setting the name
// (and title, if supplied)
// The initial capacity is set to something of the order of the number
// of objects in the table: O(100)

  fInitCap = 100;
  fReHash = 0;
  SetName(Name);
  if(Title)
    SetTitle(Title);
  else
    SetTitle(Name);
  fHashTable = new THashTable(fInitCap, fReHash);
}

TPhHashContainer::~TPhHashContainer()
{
// Destructor. Delete TPhHashContainer and all the data objects
// currently owned by TPhHashContainer

  if(fHashTable) { 
    fHashTable->Delete();
    delete fHashTable;
  }
}

void TPhHashContainer::Add(TObject *object)
{
  // Disallow adding TObject type objects. Only TPhDataObject types are 
  // allowed.

  Warning("Add", "Can't add an object of type TObject!"\
	  " Use TPhObjectContainer instead.\n"); 
}

void TPhHashContainer::Add(TPhDataObject *object)
{
  // Add an object to the hashtable. The object has to be a TPhDataObject!
  // Use TPhObjectContainer if you have an object that you want to store, 
  // but that inherits from TObject.

  if(!fHashTable)
    fHashTable = new THashTable(fInitCap, fReHash);;

  fHashTable->Add(object);
}

void TPhHashContainer::ls(Option_t *option)
{
// List all objects in the data container. 
// Use option 'D' to list all data objects.

    IndentLevel();
    cout << IsA()->GetName() << " Name: " << GetName() 
	 << " contains " << fHashTable->GetSize() 
	 << " objects" << endl;
    TObject::IncreaseDirLevel();
    if(strstr(option,"D") || strstr(option,"d"))
      fHashTable->ls(option);

    TObject::DecreaseDirLevel();
}


void TPhHashContainer::Print(Option_t *option)
{
// List all objects in the data container. 
// Use "number" as an option to indicate how many sublevels should be listed

  Char_t aoption1[5];
  Int_t level = atoi(option);
  if(level>=0) {
     level -=1;

     sprintf(aoption1,"%4d",level);
  } else return;

  printf(">>%s<<  Name: %s  contains %d objects\n", IsA()->GetName(), GetName(), 
         GetEntries());

  if(level>=0) {
    fHashTable->Print(aoption1);
  }
}

void TPhHashContainer::Draw(Option_t *option)
{
  // Call Draw() for all the objects inside the container. 

  fHashTable->Draw(option);
}



