#include "TPhNoteManager.h"

ClassImp(TPhNoteManager)


////////////////////////////////////////////////////////////////////////////
//                                                                        //
// TPhNoteManager is a PHOBOS class for storing                           //
// various text notes in a list of TPhNotes objects                       //
//                                                                        //
// $Id: TPhNoteManager.cxx,v 1.2 1998/12/15 21:48:08 decowski Exp $
//                                                                        //
////////////////////////////////////////////////////////////////////////////

TPhNoteManager::TPhNoteManager()
{
// Default onstructor. 
// Use TPhNoteManager(Int_t run, Int_t event) instead

  fNotes = NULL;
}

TPhNoteManager::TPhNoteManager(Char_t *name, Char_t *title)
{
// User constructor. 

  SetName(name);
  SetTitle(title);
  fNotes = NULL;
}

TPhNoteManager::~TPhNoteManager()
{
// Destructor. 

   SafeDelete(fNotes);
}

Int_t TPhNoteManager::GetNNotes()
{
  // Get number of note objects in the list

  if(!fNotes) return 0;
  return fNotes->GetSize();
}

void TPhNoteManager::AddNotes(TPhNotes *not)
{
  // Add TPhNotes object to the list

  if(!fNotes) fNotes = new TList();
  fNotes->Add(not);
  return;
}

TPhNotes *TPhNoteManager::GetNotes(Int_t pos)
{
  // Get TPhNotes notes object 

  if(!fNotes) return NULL;
  if((pos>fNotes->GetSize()-1) || (pos<0)) {
    Warning("GetNotes","Position %d out of range\n",pos);
    return NULL;
  }

  return (TPhNotes *) fNotes->At(pos);
}

void TPhNoteManager::ls()
{
  // Print all notes, their names and titles only
  Int_t pos, listsize;
  TPhNotes *notes;

  listsize = fNotes->GetSize();
  for(pos=0;pos<listsize;pos++) {
    notes = (TPhNotes *) fNotes->At(pos);
    notes->ls();
  }
  return;
}
  
void TPhNoteManager::Print()
{
  // Print all notes
  Int_t pos, listsize;
  TPhNotes *notes;

  listsize = fNotes->GetSize();
  for(pos=0;pos<listsize;pos++) {
    notes = (TPhNotes *) fNotes->At(pos);
    notes->Print();
  }
  return;
}
  
void TPhNoteManager::Print(Int_t pos)
{
  // Print notes at position pos
  Int_t listsize;
  TPhNotes *notes;

  listsize = fNotes->GetSize();
  if(pos<listsize) notes = (TPhNotes *) fNotes->At(pos);

  notes->Print();
  return;
}
  
void TPhNoteManager::Print(Char_t *name)
{
  // Print notes by their name
  TPhNotes *notes;

  notes = (TPhNotes *) fNotes->FindObject(name);

  notes->Print();
  return;
}
  
