#include <iostream.h>
#include <stdlib.h>
#include "TPhTrack.h"
#include "TPhRecTrack.h"
#include "TPhStuff.h"

ClassImp(TPhRecTrack)

///////////////////////////////////////////////////////////////////////
//                                                                   //
//    TPhRecTrack                                                    //
//                                                                   //
//    TPhRecTrack is the PHOBOS track class for reconstructed tracks //
//                                                                   //
// $Id: TPhRecTrack.cxx,v 1.2 1998/11/20 23:50:33 decowski Exp $
//
///////////////////////////////////////////////////////////////////////


void TPhRecTrack::ls(Option_t *option)
{
  // List the track object short info

  Int_t nhits = 0;
  nhits = GetHitList()->GetEntries();
  IndentLevel();
  cout << IsA()->GetName() << " Name: " << GetName() << "  " << nhits 
       << " hits." << endl;
}

void TPhRecTrack::Print(Option_t *option)
{
  // List the track object info
  // Use "number" as an option to indicate how many sublevels should be listed

  printf("-------------------------------------------------------------------------------\n");
  printf("RecTrack: Chi2, NDof, Prob:  %8.3g  %8.3g  %8.3g \n",
          fChi2, fNDof, fProb);
  TPhTrack::Print(option);
}

Float_t TPhRecTrack::CountProb(TPhStuff *stuff)
{
  // Calculate probability that this track with given chi2 and ndof 
  // is a correct track

   fProb = stuff->GetProb(fChi2, fNDof);

   return fProb;
}


