#ifndef __TPhChannelCalTB98__
#define __TPhChannelCalTB98__


///////////////////////////////////////////////////////////////////////////
//                                                                       //
//    TPhChannelCalTB98                                                  //
//                                                                       //
//    Phobos class to store calibration data for a single channel        //
//                                                                       //
//    TPhChannelCalTB98 is a class storing calibration information       //
//    for a single channel.                                              //
//    Test Beam 98 specific calibration (poly 2nd order)                 //
//                                                                       //
//    Author  : Andrzej Olszewski (andrzej.olszewski@ifj.edu.pl)         //
//    Created : 1/02/99                                                  //
//    Version : 1.0                                                      //
//    Changed :                                                          //
//                                                                       //
// $Id: TPhChannelCalTB98.h,v 1.1 1999/02/24 22:35:22 olszewsk Exp $
//                                                                       //
///////////////////////////////////////////////////////////////////////////

// ROOT classes

// Phat classes
#include "TPhChannelCalAbs.h"

class TPhChannelCalTB98 : public TPhChannelCalAbs {

public:

  TPhChannelCalTB98();
  TPhChannelCalTB98(Int_t parno, Int_t parpointsno, Float_t boardlinearity,
		    Float_t *pars, Float_t *calpoints, 
		    Float_t *parerrors=NULL, Float_t *relerrors=NULL);
  virtual ~TPhChannelCalTB98();

  virtual Bool_t Calibrate(Float_t &ADC);

public:

  ClassDef(TPhChannelCalTB98,1)	// Calibrate ADC for each channel (poly 2nd order)
};


#endif // __TPhChannelCalTB98__
