#ifndef __TPhChip__
#define __TPhChip__


///////////////////////////////////////////////////////////////////////////
//                                                                       //
//    TPhChip                                                            //
//                                                                       //
//    Phobos chip (bonding pattern) class                                //
//                                                                       //
//    TPhChip is a class storing information on properties of electronic //
//    channels withing one chip (bonding pattern).                       //
//                                                                       //
//    Author  : Andrzej Olszewski (andrzej.olszewski@ifj.edu.pl)         //
//    Created : 20/02/98                                                 //
//    Version : 1.0                                                      //
//    Changed :                                                          //
//                                                                       //
// $Id: TPhChip.h,v 1.1 1999/02/24 22:24:25 olszewsk Exp $
//                                                                       //
///////////////////////////////////////////////////////////////////////////

// ROOT classes
#include "TClass.h"
#include "TH1.h"

// Phat classes

class TPhChip : public TObject {

public:

  TPhChip();
  TPhChip(UShort_t fecno, UShort_t stringno, UShort_t chipno, UShort_t chipsize);
  virtual ~TPhChip();

  UShort_t           GetFECNo()             { return fFECNo;    }
  UShort_t           GetStringNo()          { return fStringNo; }
  UShort_t           GetChipNo()            { return fChipNo;   }
  UShort_t           GetChipSize()          { return fChipSize; }
             
  void               ls(Option_t *option = "");
  void               Print(Option_t *option = "");

protected:

  UShort_t      fFECNo;                        // FEC number
  UShort_t      fStringNo;                     // String number in a FEC
  UShort_t      fChipNo;                       // Chip number in a string
  UShort_t      fChipSize;                     // No of channels connected to this chip

public:

  ClassDef(TPhChip,1)	// Chip properties
};


#endif // __TPhChip__
