#ifndef _PhEDigi_INCLUDED_
#define _PhEDigi_INCLUDED_

///////////////////////////////////////////////////////////////////////
//                                                                   //
//    TPhEDigi                                                       //
//                                                                   //
//    Author  : Krzysztof Wozniak                                    //
//    Created : September 14 1997                                    //
//    Version : 1.0                                                  //
//    Changed : 30.09.1997 Andrzej Olszewski                         //
//                                                                   //
// $Id: TPhEDigi.h,v 1.2 1998/04/30 14:43:59 decowski Exp $
// 
///////////////////////////////////////////////////////////////////////

#include "TObject.h"

// Phobos classes

class TPhEDigi : public TObject {

public:
    TPhEDigi();

    virtual ~TPhEDigi();

    Short_t   EtoADC(Double_t energy);
    Double_t  ADCtoE(Short_t ADC);
    void      Print();

    void      SetFullADCRange(Short_t Range) { fFullADCRange = Range; }
    void      SetPedestal(Short_t Pedestal) { fPedestal = Pedestal; }
    void      SetFullERange(Double_t Range) { fFullERange = Range; }
    
    Short_t   GetFullADCRange() { return fFullADCRange; }
    Short_t   GetPedestal() { return fPedestal; }
    Double_t  GetFullERange() { return fFullERange; }

private:
    Short_t  fFullADCRange; // full ADC range
    Short_t  fPedestal;     // ADC pedestal value
    Double_t fFullERange;   // full E range

public:
    ClassDef(TPhEDigi,1)         // Energy <-> ADC converter

};

#endif

