#ifndef _TPhPaddleSensor_
#define _TPhPaddleSensor_

////////////////////////////////////////////////////////////////////////////
//
// TPhPaddleSensor
//
// This class has the description and functionality of the Paddle Trigger 
// Sensor. 
//
// Created 980429 by P. Decowski
//
////////////////////////////////////////////////////////////////////////////

#include "TPhTriggerSensor.h"

class TPhPaddleSensor : public TPhTriggerSensor {

public:

  TPhPaddleSensor();
  virtual ~TPhPaddleSensor();

  virtual void       Draw(Option_t *option = "");
  virtual void       SetParameters(Float_t Dx1, Float_t Dx2, 
				    Float_t Dy, Float_t Dz);

private:
  Float_t fDx1;   // half-length along x at the z surface positioned at -DZ
  Float_t fDx2;   // half-length along x at the z surface positioned at +DZ
  Float_t fDy;    // half-length along the y-axis
  Float_t fDz;    // half-length along the z-axis

public:

  ClassDef(TPhPaddleSensor,1)    // Paddle Trigger counter

};

#endif // TPhPaddleSensor

