#ifndef _TPhTOFSensor_
#define _TPhTOFSensor_

/////////////////////////////////////////////////////////////////////////////
//
// TPhTOFSensor
//
// This class is the description of the TOF sensor elements. 
//
// Created 971219 by P. Decowski
//
// $Id: TPhTOFSensor.h,v 1.3 1999/01/13 18:12:57 decowski Exp $
//
/////////////////////////////////////////////////////////////////////////////

#include "TPhBoxSensor.h"

class TPhTOFSensor : public TPhBoxSensor {

public:

  TPhTOFSensor(); 

  virtual ~TPhTOFSensor() { }
  virtual void Draw(Option_t *option="");

  virtual Int_t        MakeHitArraysOutOfHits(Char_t *HitConName,
                                              Char_t *HitArrayConName);
  
  virtual Int_t        GetRows()                 { return fRows;       }
  virtual Int_t        GetColumns()              { return fColumns;    }
  virtual void         SetRows(Int_t num)      { fRows  = num;   }
  virtual void         SetColumns(Int_t num)   { fColumns  = num;   }

private:
  Int_t         fRows;          //  # of 'vertical' segments;
  Int_t         fColumns;       //  # of 'horizontal' segments;

public:
  ClassDef(TPhTOFSensor,1) // TOF Sensor class

};

#endif /*  _TPhTOFSensor_ */
