#include <iostream.h>
#include "TClass.h"
#include "TPhChannelCalAbs.h"

ClassImp(TPhChannelCalAbs)

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// Methods to calibrate ADC signals in each separate channel.              //
//                                                                         //
// $Id: TPhChannelCalAbs.cxx,v 1.1 1999/02/24 22:48:07 olszewsk Exp $
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

TPhChannelCalAbs::TPhChannelCalAbs()
{
  // Default constructor

  fParNo = 0;
  fParPointsNo = 0;
  fCalLinearity = 1.0;
  fPars.Set(0); 
  fParErrors.Set(0);            
  fCalPoints.Set(0);      
  fRelErrors.Set(0);      
}  

TPhChannelCalAbs::TPhChannelCalAbs(Int_t parno, Int_t parpointsno, Float_t boardlinearity,
				   Float_t *pars, Float_t *calpoints, 
				   Float_t *parerrors, Float_t *relerrors)
{
  // Normal constructor
  fParNo = parno;
  fParPointsNo = parpointsno;
  fCalLinearity = boardlinearity;
  fPars.Set(parno,pars); 
  fCalPoints.Set(parpointsno,calpoints); 
  if(parerrors) fParErrors.Set(parno,parerrors);
  else          fParErrors.Set(0); 
  if(relerrors) fRelErrors.Set(parpointsno,relerrors);
  else          fRelErrors.Set(0);
}  

TPhChannelCalAbs::~TPhChannelCalAbs()
{
  // Default destructor
}  
  
void  TPhChannelCalAbs::ls(Option_t *option) 
{
  //
    Int_t i;
    IndentLevel();
    cout << IsA()->GetName() << endl << " Calibration points: ";
    for(i=0; i<fParPointsNo; i++) 
      cout << fCalPoints[i];
    cout << endl << " Parameters: ";
    for(i=0; i<fParNo; i++) 
      cout << fPars[i];
    cout << endl;
    TObject::IncreaseDirLevel();
}

void  TPhChannelCalAbs::Print(Option_t *option) 
{
  //

}
