#include "TPhHighEtaSensor.h"

#include "TTUBE.h"

ClassImp(TPhHighEtaSensor)
///////////////////////////////////////////////////////////////////////////
//
// High Eta Trigger Sensor class
//
// This is class implements the geometry and functionality of the High Eta
// Trigger counters. 
//
// $Id: TPhHighEtaSensor.cxx,v 1.2 1998/10/22 16:16:12 decowski Exp $
//
///////////////////////////////////////////////////////////////////////////

TPhHighEtaSensor::TPhHighEtaSensor()
{
  fRmin = 0;
  fRmax = 0;
  fDz = 0;
}

TPhHighEtaSensor::~TPhHighEtaSensor()
{
  // Default destructor

  SafeDelete(fShape);
}

void TPhHighEtaSensor::Draw(Option_t *Option)
{
  SetLineColor(kRed);
  TPhSensor::Draw(Option);
}

void TPhHighEtaSensor::SetParameters(Float_t Rmin, Float_t Rmax, 
				     Float_t Dz)
{
  // Set shape parameters to TUBE

  Char_t name[40];
  fRmin = Rmin;
  fRmax = Rmax;
  fDz = Dz;

  sprintf(name, "Tube_%s", GetName());
  fShape = new TTUBE(name, name, "", fRmin, fRmax, fDz);

}
