void phatic(Int_t flag = 0)
{
//  Macro phatic.C for interactive control of the MDC1 overall event
//  loop macro phat.C; phatic isn't needed if running batch.   DMcL 8/22/98

//  phatic uses the simple tools TButton and the methods obtained
//  by loading the root tutorial macro dialog.C (done in phat.C).
//     phatic calls another macro phatset which stores as static the
//  results of button changes so they may be retrieved by phat.C 
//  asynchronously.
//  For flag = 1, the initial canvas is brought up which allows one
//  to turn on one or more phat "processors"; these all run in batch.
//  For flag = 2, the run phase canvas appears with run state and
//  display controls.
//  For flag = 3, final displays and output writing are controlled.

  //  10/15/98:  This is file phatic2.C, for a vertical bar alternative
//
////////////////////////////////////////////////////////////////////////////

  if(flag == 1) {

//   Draw the bar canvas on which the control buttons appear
   bar = new TCanvas("PHAT INIT","PHAT INIT",-5,30,100,750);
   bar->SetEditable(0);
   bar->SetFillColor(38);
   bar->SetFillStyle(3014);
   bar->Draw();

   //  "GO" button at left
   TButton *but1 = new TButton("GO","phatset(5,1);",
       .02,.02,.98,.12);
   but1->SetFillColor(2);
   but1->SetTextColor(10);
   but1->SetTextSize(0.70);
   but1->Draw();

   //  "Input" button
   TButton *but2 = new TButton("Input","phatset(1,1);",
       .02,.81,.98,.87);
   but2->SetFillColor(7);
   but2->SetTextColor(1);
   but2->SetTextSize(0.50);
   but2->Draw();

   //  "Output" button
   TButton *but3 = new TButton("Output","phatset(2,1);",
       .02,.74,.98,.80);
   but3->SetFillColor(7);
   but3->SetTextColor(1);
   but3->SetTextSize(0.50);
   but3->Draw();

   //  "Events" button
   TButton *but4 = new TButton("Events","phatset(3,1);",
       .02,.67,.98,.73);
   but4->SetFillColor(7);
   but4->SetTextColor(1);
   but4->SetTextSize(0.50);
   but4->Draw();

   //  "Runs" button
   TButton *but5 = new TButton("Runs","phatset(4,1);",
       .02,.60,.98,.66);
   but5->SetFillColor(7);
   but5->SetTextColor(1);
   but5->SetTextSize(0.50);
   but5->Draw();

   //  Add a label on the canvas 
   TText *label = new TText(0.05,0.49,"Turn on \n processors");
   label->SetTextSize(0.18);
   label->SetTextColor(10);
   label->Draw();

   //  "Vtx" button
   TButton *but6 = new TButton("Vtx","phatset(8,1);",
       .02,.41,.98,.47);
   but6->SetFillColor(4);
   but6->SetTextColor(10);
   but6->SetFraming(kTRUE);   
   but6->SetTextSize(0.50);
   but6->Draw();
   
   //  "Onl" button
   TButton *but7 = new TButton("Onl","phatset(9,1);",
       .02,.34,.98,.40);
   but7->SetFillColor(4);
   but7->SetTextColor(10);
   but7->SetTextSize(0.50);
   but7->SetFraming(kTRUE);   
   but7->Draw();

   //  "Mul" button
   TButton *but8 = new TButton("Mul","phatset(10,1);",
       .02,.27,.98,.33);
   but8->SetFillColor(4);
   but8->SetTextColor(10);
   but8->SetTextSize(0.50);
   but8->SetFraming(kTRUE);   
   but8->Draw();

   //  "Spc" button
   TButton *but9 = new TButton("Spc","phatset(11,1);",
       .02,.20,.98,.26);
   but9->SetFillColor(4);
   but9->SetTextColor(10);
   but9->SetTextSize(0.50);
   but9->SetFraming(kTRUE);   
   but9->Draw();

   //  "Out" button
   TButton *but10 = new TButton("Out","phatset(12,1);",
       .02,.13,.98,.19);
   but10->SetFillColor(4);
   but10->SetTextColor(10);
   but10->SetTextSize(0.50);
   but10->Draw();

   //  "HELP" button at right
   TButton *but11 = new TButton("HELP","gSystem.Exec("$PHATHELP");",
         .02,.88,.98,.98);
   but11->SetFillColor(8);
   but11->SetTextColor(10);
   but11->SetTextSize(0.40);
   but11->Draw();

   bar->cd();
   bar->Update();
  }
////////////////////////////////////////////////////////////////////////////

  if(flag == 2) {
// Delete the canvas left from flag = 1:
   bar->Close();

//   Draw the bar canvas on which the control buttons appear
   bar = new TCanvas("PHAT RUN","PHAT RUN",-5,30,100,750);
   bar->SetEditable(0);
   bar->SetFillColor(38);
   bar->SetFillStyle(3014);
   bar->Draw();

   //  "STOP" button at left
   TButton *but1 = new TButton("STOP","phatset(6,1);",
       .02,.02,.98,.12);
   but1->SetFillColor(2);
   but1->SetTextColor(10);
   but1->SetTextSize(0.50);
   but1->Draw();

   //  "Pause" button
   TButton *but2 = new TButton("Pause","phatset(7,1);",
       .02,.76,.98,.84);
   but2->SetFillColor(7);
   but2->SetTextColor(1);
   but2->SetTextSize(0.50);
   but2->Draw();

   //  "Resume" button
   TButton *but3 = new TButton("Resume","phatset(7,0);",
       .02,.64,.98,.72);
   but3->SetFillColor(7);
   but3->SetTextColor(1);
   but3->SetTextSize(0.40);
   but3->Draw();

   //  Add a label on the canvas 
   TText *label = new TText(0.1,0.53,"Set\nDisplay\nType");
   label->SetTextSize(0.20);
   label->SetTextColor(10);
   label->Draw();

   //  "Vtx" button
   TButton *but6 = new TButton("Vtx","phatset(13,0);",
       .02,.45,.98,.53);
   but6->SetFillColor(4);
   but6->SetTextColor(10);
   but6->SetTextSize(0.50);
   but6->Draw();

   //  "Onl" button
   TButton *but7 = new TButton("Onl","phatset(14,0);",
       .02,.35,.98,.43);
   but7->SetFillColor(4);
   but7->SetTextColor(10);
   but7->SetTextSize(0.50);
   but7->Draw();

   //  "Mul" button
   TButton *but8 = new TButton("Mul","phatset(15,0);",
       .02,.25,.98,.33);
   but8->SetFillColor(4);
   but8->SetTextColor(10);
   but8->SetTextSize(0.50);
   but8->Draw();

   //  "Spc" button
   TButton *but9 = new TButton("Spc","phatset(16,0);",
       .02,.15,.98,.23);
   but9->SetFillColor(4);
   but9->SetTextColor(10);
   but9->SetTextSize(0.50);
   but9->Draw();

   //  "HELP" button at right
   TButton *but11 = new TButton("HELP","gSystem.Exec("$PHATHELP");",
         .02,.88,.98,.98);
   but11->SetFillColor(8);
   but11->SetFillColor(8);
   but11->SetTextColor(10);
   but11->SetTextSize(0.50);
   but11->Draw();

   bar->Modified();
   bar->cd();
   bar->Update();
  }
////////////////////////////////////////////////////////////////////////////

  if(flag == 3) {
// Delete the canvas left from flag = 2:
   bar->Close();

//   Draw the bar canvas on which the control buttons appear
   bar = new TCanvas("PHAT END","PHAT END",-5,30,100,500);
   bar->SetEditable(0);
   bar->SetFillColor(38);
   bar->SetFillStyle(3014);
   bar->Draw();

   //  "EXIT" button at left; sends special code (10) to doGo
   TButton *but1 = new TButton("EXIT","phatset(6,10);",
       .02,.02,.98,.12);
   but1->SetFillColor(2);
   but1->SetTextColor(10);
   but1->SetTextSize(0.60);
   but1->Draw();

   //  A lot of blank space for 2 missing buttons, temporarily.

   // The following set the display type using fl***, just as in
   // the second (event loop) phase.

   //  "Vtx" button
   TButton *but6 = new TButton("Vtx","phatset(13,0);",
       .02,.73,.98,.83);
   but6->SetFillColor(4);
   but6->SetTextColor(10);
   but6->SetTextSize(0.50);
   but6->Draw();

   //  "Onl" button
   TButton *but7 = new TButton("Onl","phatset(14,0);",
       .02,.55,.98,.65);
   but7->SetFillColor(4);
   but7->SetTextColor(10);
   but7->SetTextSize(0.50);
   but7->Draw();

   //  "Mul" button
   TButton *but8 = new TButton("Mul","phatset(15,0);",
       .02,.37,.98,.47);
   but8->SetFillColor(4);
   but8->SetTextColor(10);
   but8->SetTextSize(0.50);
   but8->Draw();

   //  "Spc" button
   TButton *but9 = new TButton("Spc","phatset(16,0);",
       .02,.19,.98,.29);
   but9->SetFillColor(4);
   but9->SetTextColor(10);
   but9->SetTextSize(0.50);
   but9->Draw();

   //Same as before:

   //  "HELP" button at right
   TButton *but11 = new TButton("HELP","gSystem.Exec("$PHATHELP");",
         .02,.88,.98,.98);
   but11->SetFillColor(8);
   but11->SetTextColor(10);
   but11->SetTextSize(0.60);
   but11->Draw();

  }
}















