{
// plotfile.C: ROOT macro to plot from a file of TGraphErrors
// Use:
// .x plotfile.C
// and follow prompts.
// 27-Aug-98:  Robin Verdier

// Default file name:
  Char_t *plotFile = "~verdier/mul/work/mulOut.root";

  Int_t MaxPlots = 1000; // For compiled code, these need to be consts
  Int_t MaxReply = 120;
  Int_t MaxKey = 10;

  TGraphErrors *plots[MaxPlots];
  Char_t key[MaxKey];
  Char_t reply[MaxReply];
  Int_t iPlot = 0;

  printf ("Name of file containing graphs [cr=%s]\n: ",
    plotFile);
  if (fgets(reply, MaxReply, stdin))
  { reply[strlen(reply)-1] = 0;
    if (reply[0]) strcpy(plotFile, reply);
  }
  TFile *f1 = new TFile(plotFile);
  if (!f1)
    printf ("Unable to open file %s.\n");
  else
  { strcpy (reply, "n");
    printf ("List the objects in the file (may be LONG!) (y|n) [cr=n]: ");
    if (fgets (reply, MaxReply, stdin) && !strcmp(reply,"y\n")) f1->ls();
    TCanvas *c1 = new TCanvas("c1", plotFile, 0, 0, 400, 400);
    strcpy (key, "d0");
    while (strcmp(key,"e"))
    { printf ("Name of graph #%d to plot [cr=%s, e to exit]: ", iPlot, key);
      if (fgets(reply, MaxReply, stdin))
      { reply[strlen(reply)-1] = 0;
        if (reply[0]) strncpy(key, reply, MaxKey);
      }
      if (strcmp(key, "e"))
      { if (plots[iPlot]) plots[iPlot]->Delete();
        plots[iPlot] = (TGraphErrors *)f1->Get(key);
        if (plots[iPlot])
        { c1->Clear();
          plots[iPlot]->Draw("ape");
          c1->Update();
          iPlot++;
        }
        else 
        { printf ("Plot %s not found.\n", key);
          plots[iPlot] = NULL;
        }
      }
    }
    printf ("If you don\'t delete these graphs, you can redraw and manipul"
      "ate\n graph #n via plots[n], e.g., plots[5]->Draw(\"ape\").\n");
    printf ("Delete created graphs (y|n) [cr=y]? ");
    if (fgets(reply,MaxReply,stdin)
      && (!strcmp(reply,"y") || !strcmp(reply,"\n")))
      for (Int_t iPlot = 0; iPlot < MaxPlots; iPlot++)
        if (plots[iPlot])
        { plots[iPlot]->Delete();
          plots[iPlot] = NULL;
        }
  } // if (!f1
}
