{
// printhist.cxx: formatted printout of the contents of a TH2F
// Use: .L printhist.cxx
//      printhist(hh)
// where hh is a TH2F * given in the Multiplicity package, say, by
//   TH2F *s1 = mp.GetHist("s1","MOBA",0);
// X and Y values are listed at bin CENTERS.
// Note that the GetCellContent method includes underflow and 
// overflow bins in its indexing.
// 13-Jul-98  Robin Verdier

  Int_t printhist ( TH2F *th; )
  { if (th)
    { Int_t nPerLine = 8;
      Int_t nBins[2];
      Float_t cMin[2], cMax[2], cBin[2];
      for (Int_t ixy = 0; ixy < 2; ixy++)
      { TAxis *ta;
        if (ixy == 0) ta = th->GetXaxis();
        else ta = th->GetYaxis();
        nBins[ixy] = ta->GetNbins();
        cMin[ixy] = ta->GetXmin();
        cMax[ixy] = ta->GetXmax();
        cBin[ixy] = (cMax[ixy] - cMin[ixy]) / nBins[ixy];
      }
      printf ("Title = %s, name = %s, %d x %d bins\n", th->GetTitle(), 
        th->GetName(), nBins[0], nBins[1]);
      Int_t iXMax = -1;
      while (iXMax < nBins[0] - 1)
      { Int_t iXMin = iXMax + 1;
        iXMax = iXMin + nPerLine - 2;
        if (iXMax > nBins[0] - 1) iXMax = nBins[0] - 1;
        printf ("  Y   X = ");
        for (Int_t ix = iXMin; ix <= iXMax; ix++)
          printf ("%10.2e", cMin[0] + (ix + 0.5) * cBin[0]);
        printf ("\n");
        for (Int_t iy = 0; iy < nBins[1]; iy++)
        { printf ("%10.2e", cMin[1] + (iy + 0.5) * cBin[1]);
          for (Int_t ix = iXMin; ix <= iXMax; ix++)
            printf ("%10.3e", th->GetCellContent(ix+1, iy+1));
          printf ("\n");
        }
        printf ("\n");
      }
    }
    else printf ("%p is not a valid address for TH2F th.\n", th);
  }
}
