#ifndef __TPhOnFEC__
#define __TPhOnFEC__


#include "TPhOnContainer.h"

class TObjArray;
class TCanvas;
class TPad;

class TPhOnFEC : public TNamed { 

public:
  TPhOnFEC();
  TPhOnFEC(Int_t FECNr);
  Int_t          Init();
  void           Fill();
  void           Reset();
  void           Draw(Int_t StringNr);
  void           Draw(Int_t StringNr,Option_t *option);
  void           ListHisto(Option_t *option = "ALL");
  Bool_t         Check(Option_t *option = "ALL");
  Bool_t         Check(Int_t StringNr, Option_t *option = "ALL");

  
  ~TPhOnFEC();


protected:
  TObjArray *fStringArray;          // array of TPhOnString obj of this fec
  Int_t fNChanRead;                 // nr of channels read
  Int_t fNEvent;                    // nr of events analyzed
  Int_t fNString;                   // nr of strings in FEC		
  Int_t fFECNr;			    // FEC nr  
  TCanvas *fCanvas;		    //! canvas to draw histograms

  ClassDef(TPhOnFEC,2)  // online class for fec based info 

};

#endif // __TPhOnFEC__ 


