#ifndef _TPhStopDisplay_INCLUDED_
#define _TPhStopDisplay_INCLUDED_
//#define DEBUG
//
///////////////////////////////////////////////////////////////////////
//                                                                   //
//    TPhStopDisplay                                                 //
//                                                                   //
//    Phobos class for showing a stoping particle  in an event       //
//                                                                   //
//                                                                   //
///////////////////////////////////////////////////////////////////////


#include "TObject.h"
#include "TPolyLine.h"
#include "TPolyMarker.h"
#include "TMarker.h"
#include "TH2.h"
#include "TNtuple.h"


class TPhStop;
class TPhEvent;
class TPhTrack;
class TPhMCTrack;
class TPhMCHit;
class TPhVertex;
class TPhDetector;
class TPhMomentumVector;

class TPhStopDisplay : public TObject 
{ 
  //friend class TPhStop;
 public:
  TPhStopDisplay();
  virtual ~TPhStopDisplay();

  virtual void                SetVerbose      ( Int_t n)  { fVerbose = n; }
  virtual void                SetStop         ( TPhStop *Stop)  { fStop = Stop; }
  virtual void                SetDetector     ( TPhDetector *det){ fDetector=det ;}
  virtual void                SetEvent        ( TPhEvent *event)  { fEvent = event;}
  virtual void                DrawRawEvent    ( TPhObjectContainer *StuckTracksBuffer );
  virtual void                DrawMCEvent     ( TPhObjectContainer *StuckTracksBuffer);
  virtual void                DrawMCTrack     ( TPhMCTrack *track);
  virtual TPhObjectContainer* MethodEvl       ( TPhEvent *Event, 
						TPhObjectContainer *StuckTracksBuffer, 
						Int_t *Test);
  virtual TPhObjectContainer* PickStpPtl      ( TPhObjectContainer *TracksBuffer );
  virtual void                PrintEvent      ( TPhObjectContainer *StuckTracksBuffer );
  virtual TPhMCTrack         *GetMCTrack      ( Int_t TrackNo );
  virtual void                PrintMCEvent    ( TPhObjectContainer *StuckMCTracksBuffer );
  virtual Int_t               MC2R            ( TPhMCTrack *MCtrack, TPhMCTrack *Rtrack  );
  virtual Int_t               RID             ( TPhTrack *Rtrack  );
  virtual void                MassvsEloss     ( TPhEvent *event, TH2F *h1, TH2F *h2, TH2F *h3);
  virtual void                DAngle_Theta    ( TPhEvent *event, TH1F *h0, TH1F *h1, TH1F *h2, 
					                        TH1F *h3, TH1F *h4);
  virtual void                DAngle_Phi      ( TPhEvent *event, TH1F *h0, TH1F *h1, TH1F *h2, 
					                        TH1F *h3, TH1F *h4, TH2F *h);
  virtual void                Clear(TPhObjectContainer *StuckTracksBuffer);
  // data members

 private:
    TPhDetector        *fDetector;              //! Detector object for data access
    TPhStop            *fStop;                  //! 
    TPhEvent           *fEvent;                 //! PHOBOS event object
    Bool_t              fVerbose;               //! Control debugging output
    TPhObjectContainer *fStuckMCTracksBuffer;   //! 
    TPolyLine          *fPolyLine;    
    TPolyMarker        *fPolyMarker;    
    TMarker            *x[10];
    TMarker            *xr[100];
public:

    ClassDef(TPhStopDisplay,1) // TPhStopDisplay class to find and identify stoping ptls 

};

#endif
