{

// find stopping ptls macro: fsp.C
 
// Clean the ROOT environment 

gROOT->Reset();
gROOT->Time(); 

const Char_t *phathome = gSystem->Getenv("PHATHOME");
printf("Found PHAT home at %s\n",phathome);

TH1F mom("mom","The mass parameter distribution of the found stopping ptls",100.,0.,0.5);

// Create a few important objects

Char_t FileGeom[256];

// files containing stopping pions kaons and protons

sprintf(FileGeom,"P.aou",""); 

TPhDetector *det = TPhDetector::ReadLatestGeometry();

TPhASCIIData *data = new TPhASCIIData(FileGeom);

Int_t num = 0;

TPhEvent *event;
TPhTrack *track;

TPhStop *STOP = new TPhStop("../../init/TPhStop.DAT4");
STOP->SetVerbose(0);
STOP->SetDetector(det);
TPhObjectContainer *StuckTracksBuffer;
TPhObjectContainer *StuckMCTracksBuffer;

Char_t arm='N';

Int_t mod=100;
Int_t ncandM;
 
while(num < 100) 
{
  if(num%mod==0)printf("\n Processing event : %d \n",num);
  num++;
  //TPhEvent *event     = dst->GetNextEvent();
    TPhEvent *event     = data->GetNextEvent();
  
  arm = 'P';

  StuckTracksBuffer   = STOP->GetStoppingPtls(event,arm);
  ncandM = 0;
  if(StuckTracksBuffer)ncandM = StuckTracksBuffer->GetEntries();
  printf("%d %d \n",num,ncandM);
  
  TIter NextTrack(StuckTracksBuffer->GetObjectList());  
  while(track = (TPhTrack *) NextTrack() )
    mom->Fill(track->GetMass());
  STOP   ->Clear(StuckTracksBuffer);
  delete event;
}
delete StuckTracksBuffer;
mom.Draw();
}





