      SUBROUTINE ADDPMCDEVO(N, DNAME, ISHAPE, CENTER,
     +      NPAR, DETPAR,  NROT, IDETROT,  IPADFL, PADPAR)
*Documentation_Block
************************************************************************
*
*  Description:
*  Interface to PHAT memory (dummy version to be linked with standalone PMC)
*
*  Arguments:
*   N       - detector volume number
*   DNAME   - detector volume name
*   ISHAPE  - shape type (Geant)
*   CENTER  - position of the volume central point
*   NPAR    - number of volume parameters
*   DETPAR  - table of volume parameters
*   NROT    - number of rotation matrices to by applied to the volume
*   DETROT  - table of rotation matrices numbers
*   IPADFL  - pad type
*   PADPAR  - table of pad parameters
*
*  Called by:
*  PH_GEOM
*
*  Calls:
*
*  Implicit inputs, outputs, side effects:
*  none
*
*  History:
*  Date       Name       Description
*  ----       ----       -----------
*   27-Apr-98  K.W.    Creation
************************************************************************
*End_Documentation_Block

      IMPLICIT NONE

      CHARACTER*4 DNAME
      INTEGER  N, ISHAPE, NPAR, NROT, IPADFL, IDETROT(20)
      REAL  CENTER(3), DETPAR(40), PADPAR(10)

      INTEGER I
C
C     Executable Statements
C     =====================
C

      WRITE(99, '('' G DEVO '', A4, I4, 3I3, 3F11.5)' )
     +      DNAME, N, ISHAPE, NPAR, NROT, CENTER
      WRITE(99, '(1X, I3, 10F8.4)' ) IPADFL, PADPAR
      WRITE(99, '(1X, 10F11.5)' ) (DETPAR(I),I=1,NPAR)
      WRITE(99, '(1X, 20I5)' ) (IDETROT(I), I=1,NROT)

      RETURN
      END
