      Subroutine PH_LAST
*Documentation_Block
************************************************************************
*
* Description:
* Output module for Ntuples, called at end of Geant run.
*
* Arguments: none
*
* Called by:
*  USLAST
*
* Calls:
*  HCDIR, HISTDO, HREND, HROUT, HRPUT
*
* Implicit inputs, outputs, side effects:
*   Input from listed commons
*   Output to Ntuples
*
* Filename: PMC_SRC:PH_LAST.FOR
*
* History:
* Date      Name       Description
* ----      ----       -----------
* 21-Jul-96  R. V.     Removed unused card, ier, ofname
* 22-FEB-93 R. V.      Correct directory handling via HCDIR
* 10-Jan-93 R. Verdier Make separate Hits and MC Ntuples
*    Mar-92 D. McLeod  Creation as part of GPH
************************************************************************
*End_Documentation_Block

      IMPLICIT NONE

*KEEP,GCKINE.
      COMMON/GCKINE/IKINE,PKINE(10),ITRA,ISTAK,IVERT,IPART,ITRTYP
     +      ,NAPART(5),AMASS,CHARGE,TLIFE,VERT(3),PVERT(4),IPAOLD
C
      INTEGER       IKINE,ITRA,ISTAK,IVERT,IPART,ITRTYP,NAPART,IPAOLD
      REAL          PKINE,AMASS,CHARGE,TLIFE,VERT,PVERT
C
*KEEP,IO.
C Common block for GPH logical units etc.: file IO.CMN
c 13-Aug-96  R. V.       Added USRBATCHK for KUIP commands for UGCONS
c 21-Jul-96  R. V.       Remove unused record; note CARDDEF now obsolete
c 22-Feb-93  R. V.       Added USRMCNTU and IMCNTU for MC Ntuple
c 14-Nov-92  R. Verdier  Added UGCIN, IUGCIN, CARDDEF and ICARDDEF
c                        for UGC and EUCARD (obsolete) input units
C    Apr-92  C. Parsons  Replacement for original COMMON.CDT
      INTEGER USRGCIN, CARDDEF, USRIN, USROUT, USRMAP, USRNTU, USRZEB,
     *  USRMCNTU, USRBATKUMAC
      PARAMETER (USRIN = 4, USROUT = 16, USRMAP = 18)
      PARAMETER (USRNTU = 15, USRZEB = 17, USRGCIN = 19, CARDDEF = 20)
      PARAMETER (USRMCNTU = 21, USRBATKUMAC = 22)
      INTEGER ICARDDEF, IMCNTU, IUSRGCIN, IUSRIN, IUSROUT, IUSRMAP,
     *  IUSRNTU, IUSRZEB, IUSRAOU, IUSRBATKUMAC
      COMMON /IO/ IUSRIN, IUSROUT, IUSRMAP, IUSRNTU, IUSRZEB, IUSRGCIN,
     *  ICARDDEF, IMCNTU, IUSRAOU, IUSRBATKUMAC
*KEEP,FLAG.
C  PHOBOS flags, run control, operating modes, misc.   File FLAG.CMN
C   7-Jul-98  K. W.      Added  ITRIG flag (initial numer in TRIG command)
C  27-Nov-97  K. W.      Added IAOUF flag
C  31-Mar-95  R.V.       Change STRA to SECT to avoid GEANT 3.21 conflict
C  22-Nov-92  D. McLeod
C   These are set in input cards
      INTEGER ISASC,ISHBO,ISHDO,ISNTU, ISMEM,ISAOU,IAOUF, ISECT,IDRAW,
     1        IGEN,IANAL,ISCAT,IPIXL,ISEQ,NTRK,IZEB, ITRIG
      REAL WPIXL,WLOSS
      COMMON/RHFLG/ISASC,ISHBO,ISHDO,ISNTU,
     1  ISMEM,ISAOU,IAOUF, ISECT,IDRAW,
     2  IGEN,IANAL,ISCAT,IPIXL,ISEQ,NTRK,IZEB,WPIXL,WLOSS, ITRIG
*KEND.

C
C     Local definitions:
C     ==================
C  LOCAL:
      INTEGER ICYCLE
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

C
C     Executable Statements
C     =====================
C     Print HBOOK format histograms, if requested by control card
      IF(ISHDO.NE.0)  THEN
         write(*,*) ' HBOOK PLOTS OUTPUT TO filename.OUT'
         CALL HISTDO
      ENDIF

C            Save histograms, if requested by control card
      IF(ISHBO.NE.0)  THEN
         write(*,*) ' PLOTS OUTPUT TO filename.HST'
         CALL HRPUT(0,'RHHST',' ')
      ENDIF

C            Output Ntuples, if requested by control card
      IF (IAND(ISNTU,1) .NE. 0) THEN
         write(*,*) ' Track Ntuple output to filename.NTU '
         ICYCLE = 0
c Set directory to the ntuple in memory
         CALL HCDIR ('//PAWC/RHTUP',' ')
c Set directory to the ntuple disk file
         CALL HCDIR ('//RHTUPF',' ')
         CALL HROUT (1,ICYCLE,' ')
         CALL HREND ('RHTUPF')
         CLOSE (IUSRNTU)
      ENDIF

      IF (IAND(ISNTU,2) .NE. 0) THEN
         write(*,*) ' MC Ntuple output to filename.NTU '
         ICYCLE = 0
         CALL HCDIR ('//PAWC/MCTUP',' ')
         CALL HCDIR ('//MCTUPF',' ')
         CALL HROUT (2,ICYCLE,' ')
         CALL HREND ('MCTUPF')
         CLOSE (IMCNTU)
      ENDIF

      return
      end
