C     =====================================================================
C     File: pmc_src:psking.for
	subroutine psking(NVERT)
C
C     Description:  Replacement for GEANT GSKING that adds user buffers
C     ============ to the KINE and VERT structures.
C
C
C     Arguments:
C     ==========
C	INTEGER NVERT    !Vertex to associate with track. Booked in GUSTEP
C
C     Conditions returned:
C     ====================
C
C     Implicit inputs, outputs, side effects:
C     =======================================
C
C       Called by:GUSTEP
C       Calls: GSVERT, GSKING,GSSTAK
C
C       Impicit inputs Common block GCKINE (current track) GCKING (new tracks)
C                      Stacking is controled by IFLGK in GCKING
C		       IFLGK(NTRACK)>=0 store track. <0 flushes it.
C
C
C       Implicit outputs: Adds to JSTAK KINE and VERT banks
C
C
C     Author:  C. Parsons , R Verdier.
C     =======
C
C     Creation Date: 3-July-1992
C     ==========================
C
C     Revisions:
C     ==========
C       Date     Name    Description
C       -------  ----    -------------------------------------------------
*  14-May-93  R. V.      Multipass mods: NtTot, MUPEP.CMN
C
C     Global specifictions:
C     =====================
      implicit none
      INTEGER NVERT    !Vertex to associate with track. Booked in GUSTEP
C
C     External specifications:
C     ========================
*KEEP,GCKING.
      INTEGER MXGKIN
      PARAMETER (MXGKIN=100)
      COMMON/GCKING/KCASE,NGKINE,GKIN(5,MXGKIN),
     +                           TOFD(MXGKIN),IFLGK(MXGKIN)
      INTEGER       KCASE,NGKINE ,IFLGK,MXPHOT,NGPHOT
      REAL          GKIN,TOFD,XPHOT
C
      PARAMETER (MXPHOT=800)
      COMMON/GCKIN2/NGPHOT,XPHOT(11,MXPHOT)
C
      COMMON/GCKIN3/GPOS(3,MXGKIN)
      REAL          GPOS
C
*KEEP,GCKINE.
      COMMON/GCKINE/IKINE,PKINE(10),ITRA,ISTAK,IVERT,IPART,ITRTYP
     +      ,NAPART(5),AMASS,CHARGE,TLIFE,VERT(3),PVERT(4),IPAOLD
C
      INTEGER       IKINE,ITRA,ISTAK,IVERT,IPART,ITRTYP,NAPART,IPAOLD
      REAL          PKINE,AMASS,CHARGE,TLIFE,VERT,PVERT
C
*KEEP,GCTRAK.
      INTEGER NMEC,LMEC,NAMEC,NSTEP ,MAXNST,IGNEXT,INWVOL,ISTOP,MAXMEC
     + ,IGAUTO,IEKBIN,ILOSL, IMULL,INGOTO,NLDOWN,NLEVIN,NLVSAV,ISTORY
     + ,MAXME1,NAMEC1
      REAL  VECT,GETOT,GEKIN,VOUT,DESTEP,DESTEL,SAFETY,SLENG ,STEP
     + ,SNEXT,SFIELD,TOFG  ,GEKRAT,UPWGHT
      REAL POLAR
      PARAMETER (MAXMEC=30)
      COMMON/GCTRAK/VECT(7),GETOT,GEKIN,VOUT(7),NMEC,LMEC(MAXMEC)
     + ,NAMEC(MAXMEC),NSTEP ,MAXNST,DESTEP,DESTEL,SAFETY,SLENG
     + ,STEP  ,SNEXT ,SFIELD,TOFG  ,GEKRAT,UPWGHT,IGNEXT,INWVOL
     + ,ISTOP ,IGAUTO,IEKBIN, ILOSL, IMULL,INGOTO,NLDOWN,NLEVIN
     + ,NLVSAV,ISTORY
      PARAMETER (MAXME1=30)
      COMMON/GCTPOL/POLAR(3), NAMEC1(MAXME1)
C
*KEEP,GCVOLU.
      COMMON/GCVOLU/NLEVEL,NAMES(15),NUMBER(15),
     +LVOLUM(15),LINDEX(15),INFROM,NLEVMX,NLDEV(15),LINMX(15),
     +GTRAN(3,15),GRMAT(10,15),GONLY(15),GLX(3)
C
      INTEGER NLEVEL,NAMES,NUMBER,LVOLUM,LINDEX,INFROM,NLEVMX,
     +        NLDEV,LINMX
      REAL GTRAN,GRMAT,GONLY,GLX
*KEEP,MUPEP.
c MUPEP.CMN: PHOBOS MC multi-pass event processing variables
c 16-Mar-95 K. W.     NeSkip added
c  6-Jun-93 R. V.     Creation
c Multi-pass event processing breaks up each event into groups of
c tracks, in order to avoid overflowing Zebra track storage.
c Common for access to control variables:
      common /MUPEP/ EPState, NtConc, NtpE, NtPrim, NeSkip, NtSkip,
     1  MPind, NtPrev, NtTot, NtMax, NvPrev
c Parameters and data values are assigned in MUPEP.CDA.
c Event processing state: EPState = 0 for first pass,
c 1 for continuing pass, 2 for final pass
      integer EPState
c Current pass index:
      integer MPind
c Maximum number of tracks to process concurrently in a group:
      integer NtConc
c Maximum track number for this group:
      integer NtMax
c Maximum number of tracks per event:
      integer NtpE
c Number of primary and secondary tracks generated before this pass:
      integer NtPrev
c Number of primary tracks and vertices generated:
      integer NtPrim, NvPrev
c Number of input file events to skip initially:
      integer NeSkip
c Number of tracks to skip initially:
      integer NtSkip
c Total number of primary and secondary tracks generated:
      integer NtTot
*KEEP,UJKBUF.
C  PHOBOS JKINE user buffer definitions.          File: UJKBUF.INC
c 18-Jul-94  R. V.  Added NHitsAct
	integer Nwubuf, Nwubmax, NHitsAct
	parameter (Nwubmax = 11)
	common /UJKB/ Nwubuf, Ubuf(Nwubmax), NHitsAct
	real Ubuf
	integer IUBUF(Nwubmax)
	equivalence (IUBUF, UBUF)
c NHitsAct:   The number of hits on the track being propagated
c The user words at present are:
c UBUF(1):    Process in which particle was created (DCAY, BREM etc.)
c     (2):    Parent track number, negative is parent not stored
c             (possible in SECT=1 mode)
c     (3):    Volume number at origin, (4 characters in one integer word)
c             not definded for primaries and undefined for all tracks
c             in SECT=1 mode (integer value 0)
c     (4-6):  X, Y, Z at termination
c     (7-10): Px, Py, Pz, E at termination
c     (11):   Istop at track termination, positive when particle stopped
c             in a sensitive volume, negative otherwize
*KEND.
C
C     Local definitions:
C     ==================
C.
      REAL PSTO(3), VSTO(3),TOFSTO  !Temporary storage of PVERT, VERT,TOFG
      Integer I,N   !Loop indices
     &      ,IPASTO  !Temporary storage of IPART
     &      ,ITRSTO  !Temporary storage of ITRA
     &      ,NT      !KINE bank inice of new track
C
C     Executable Statements
C     =====================
C.
C.    ******************************************************************
C.    *                                                                *
C.    * USED   TO BE THIS BUT ITS DIFFERENT NOW!!!!!                   *
C.    *                                                                *
C.    *                                                                *
C.    *    SUBR. GSKING (IGK)                                          *
C.    *                                                                *
C.    *   Stores in stack JSTAK either the IGKth track of /GCKING/,    *
C.    *    or the NGKINE tracks when IGK is 0.                         *
C.    *                                                                *
C.    *   Called by : 'User'                                           *
C.    *   Authors   : R.Brun, F.Bruyant                                *
C.    *                                                                *
C.    ******************************************************************
C.
C
C.
C.    ------------------------------------------------------------------
*
      IF (NGKINE.LE.0) GO TO 999
*
* *** Save original information from /GCKINE/ and /GCTRAK/
*
      IPASTO = IPART
      TOFSTO = TOFG
      ITRSTO = ITRA
      DO 19 I = 1,3
         VSTO(I) = VERT(I)
         PSTO(I) = PVERT(I)
   19 CONTINUE
*
* *** Store required tracks in stack JSTAK
*
      DO 90 N =  1,NGKINE
         IF (IFLGK(N).LT.0) GO TO 90
         TOFG  = TOFSTO +TOFD(N)
         IPART = GKIN(5,N)
         DO 80 I = 1,3
            VERT(I)  = VECT(I)
            PVERT(I) = GKIN(I,N)
   80    CONTINUE
c Store all the secondary tracks in JKINE, adding space for user
c words to contain stop flag, parent id, and final kimematics.
c At this point we could decide to drop low energy tracks and
c neutrinos to save time.

c Clear user buffer
	 call UZERO(UBuf, 1, Nwubmax)
	 UBuf(2) = ITRSTO + NtTot
	 IUBuf(3) = Names(NLevel)
	 call GSKINE (PVERT,IPART, NVERT, UBuf,Nwubmax, Nt)
c Force GSSTAK to use the correct track number; argument 2 makes
c GSSTAK use the existing JKINE entry.
	 ITRA = Nt
         CALL GSSTAK (2)

   90 CONTINUE

*
* *** Restore original information in /GCKINE/ and /GCTRAK/
*
      IPART = IPASTO
      ITRA  = ITRSTO
      TOFG  = TOFSTO
      DO 99 I = 1,3
         VERT(I)  = VSTO(I)
         PVERT(I) = PSTO(I)
   99 CONTINUE
*                                                             END GSKING
  999 END
