C     =====================================================================
C     File PMC_SRC:SETBATCH.FOR
      SUBROUTINE SETBATCH(IFLAG)
C
C     Description: Set the BATCH flag in GCFLAX
C     ============
C
C
C     Arguments:
C     ==========
C      Integer IFLAG  ! Set BATCH to .true. if 1  .false. otherwise
C
C     Conditions returned:
C     ====================
C
C     Implicit inputs, outputs, side effects:
C     =======================================
C
C       Called by:  User via comis
C       Calls:
C
C     Author: C. Parsons
C     =======
C
C     Creation Date: 29-June-1992
C     ==========================
C
C     Revisions:
C     ==========
C       Date     Name    Description
C       -------  ----    -------------------------------------------------
C     21-Nov-93  R. V.  Changed GCFLAX to GCFLAG (now contains old GCFLAX)
C
C     Global specifictions:
C     =====================
      implicit none
C
C     External specifications:
C     ========================
*KEEP,GCFLAG.
      COMMON/GCFLAG/IDEBUG,IDEMIN,IDEMAX,ITEST,IDRUN,IDEVT,IEORUN
     +        ,IEOTRI,IEVENT,ISWIT(10),IFINIT(20),NEVENT,NRNDM(2)
      COMMON/GCFLAX/BATCH, NOLOG
      LOGICAL BATCH, NOLOG
C
      INTEGER       IDEBUG,IDEMIN,IDEMAX,ITEST,IDRUN,IDEVT,IEORUN
     +        ,IEOTRI,IEVENT,ISWIT,IFINIT,NEVENT,NRNDM
C
*KEND.
C
C     Local definitions:
C     ==================
      Integer IFLAG  ! Set BATCH to .true. if 1  .false. otherwise
C
C     Executable Statements
C     =====================
      If(IFLAG.eq.1)then
        BATCH=.TRUE.
      Else
        BATCH=.FALSE.
      Endif
      End
