//*CMZ :  1.03/01 12/08/97  15.37.03  by  Valery Fine(fine@vxcern.cern.ch)
//*CMZ :  1.00/09 20/04/97  20.55.41  by  Valery Fine(fine@vxcern.cern.ch)
//*-- Author :    Fons Rademakers   02/03/95

//*KEEP,CopyRight,T=C.
/************************************************************************
 * Copyright(c) 1995-1997, The ROOT System, All rights reserved.
 * Authors: Rene Brun, Nenad Buncic, Valery Fine, Fons Rademakers.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation for non-commercial purposes is hereby granted without fee,
 * provided that the above copyright notice appears in all copies and
 * that both the copyright notice and this permission notice appear in
 * the supporting documentation. The authors make no claims about the
 * suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 ************************************************************************/
//*KEND.

//////////////////////////////////////////////////////////////////////////
//                                                                      //
// RMain                                                                //
//                                                                      //
// Main program used to create RINT application.                        //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

//*KEEP,TROOT.
#include "TROOT.h"
//*KEEP,TRint.
#include "TRint.h"
//*KEND.

#if  !(defined(__alpha) && defined(__unix__))
extern "C" void f_init();
extern "C" void f_exit();
#endif

int xargc;
char** xargv; 

extern void InitGui();

VoidFuncPtr_t initfuncs[] = { InitGui, 0 };

TROOT root("Rint","The ROOT Interactive Interface", initfuncs);

//______________________________________________________________________________
int main(int argc, char **argv)
{
#ifndef WIN32
   char appname[] = "Rint";
#else
   char appname[] = "Root_Rint";
#endif
   xargc = argc;
   xargv = argv;

#if  !(defined(__alpha) && defined(__unix__))
   f_init();
#endif

   TRint *theApp = new TRint(appname, &argc, argv, 0, 0);

   // Init Intrinsics, build all windows, and enter event loop
   theApp->Run();

   delete theApp;

#if  !(defined(__alpha) && defined(__unix__))
   f_exit();
#endif

   return(0);
}
