#ifndef _TPhHoughHit_
#define _TPhHoughHit_

#include "TObjArray.h"
#include "TPhRecHit.h"
#include "TPhHoughRoad.h"
#include "TPhDetector.h"
#include "TPhSiSensor.h"

class TPhHoughRoad;

class TPhHoughHit : public TPhRecHit {

protected:

  int        fUsed;        	//! int
  float      fPadSizeX;         //!
  float      fPadSizeY;         //!
  float      fTheta;            //! 
  float      fEta;              //!
  float      fPhi;              //!
  TObjArray *fHitList[2];	//! lower & upper connecting hits
  TObjArray *fRoadList[2];	//! lower & upper roads

public:

                     TPhHoughHit();
                     TPhHoughHit(TPhRecHit *rechit);
  virtual           ~TPhHoughHit();

  virtual void       SetUsed(int i){fUsed=i;} 
  virtual void       AddHit(int i, TPhHoughHit *h);
  virtual void       AddRoad(int i, TPhHoughRoad *r);

  virtual float      GetPadSizeX(){return fPadSizeX;}
  virtual float      GetPadSizeY(){return fPadSizeY;}
  virtual float      GetTheta(){return fTheta;}
  virtual float      GetEta(){return fEta;}
  virtual float      GetPhi(){return fPhi;}

  virtual int        GetUsed(){return fUsed;}
  virtual TObjArray *GetHitList(int i){return fHitList[i];}   
  virtual TObjArray *GetRoadList(int i){return fRoadList[i];}

  virtual void       Reset();
  
  ClassDef(TPhHoughHit,1)  // Hough hit class

};

#endif
