#ifndef _TPhPhQPair_INCLUDED_
#define _TPhPhQPair_INCLUDED_

#include "TObject.h"

class TPhTrack;

class TPhQPair : public TObject {
    
  public: 

    TPhQPair() { };
    virtual ~TPhQPair() { };

    TPhQPair(TPhTrack *t1, TPhTrack *t2,Bool_t Flag=0);

    void    Calc(TPhTrack *t1, TPhTrack *t2,Double_t MaxQ=1.0,Bool_t Flag=0);
    Double_t CalcQinvFast(TPhTrack *t1, TPhTrack *t2,Double_t MaxDpz = 10.0);

    Double_t GetQinv()     { return fQinv; }
    Double_t GetQt()       { return fQt;    }
    Double_t GetQlong()    { return fQlong; }
    Double_t GetQlcmp()    { return fQlcmp; }
    Double_t GetQside()    { return fQside; }
    Double_t GetQout()     { return fQout; }
    Double_t GetDp()       { return sqrt(fDpx*fDpx+fDpy*fDpy+fDpz*fDpz); }
    Double_t GetDpx()      { return fDpx; }
    Double_t GetDpy()      { return fDpy; }
    Double_t GetDpz()      { return fDpz; }
    Double_t GetGamov()    { return fGamov; }
    Double_t GetModGamov() { return fModGamov; }
    Double_t GetKt()       { return fKt; }
    Double_t GetRap()      { return fRap; }

    ClassDef(TPhQPair,1)  // TPhQPair 

  protected:
 
    Double_t fQ;
    Double_t fQ0;
    Double_t fQt;
    Double_t fQinv;
    Double_t fQside;
    Double_t fQout;
    Double_t fQlong;
    Double_t fQlcmp;

    Double_t fDp;           // Momentum Difference
    Double_t fDpx;
    Double_t fDpy;
    Double_t fDpz;

    Double_t fGamov;        // Gamov penetration factor 
    Double_t fModGamov;     // Modified Gamov penetration factor 
  
    Double_t fKt;           // Pair transverse momentum
    Double_t fRap;          // Pair average rapidity   

};

#endif
