#ifndef _TPhRandomEvent_INCLUDED_
#define _TPhRandomEvent_INCLUDED_

#include "TObject.h"
#include "TFile.h"

class TPhEvent;
class TPhTrack;

class TPhRandomEvent : public TObject {
    
  public: 
    TPhRandomEvent();

    virtual ~TPhRandomEvent() { }

    virtual void    SetTemperature(Float_t x) {   fTemperature = x;   } 
    virtual void    SetMeanRap(Float_t x)     {   fMeanRap = x;       } 
    virtual void    SetSigmaRap(Float_t x)    {   fSigmaRap = x;      } 
    virtual void    SetK2Pi(Float_t x)        {   fK2Pi = x;          } 
    virtual void    SetP2Pi(Float_t x)        {   fP2Pi = x;          } 
    virtual void    SetMult(Float_t x)        {   fMult = x;          } 
    virtual void    SetMultWidth(Float_t x)   {   fMultWidth = x;     } 
    virtual void    SetEventCounter(Int_t i)  {   fEventCounter = i;  } 

    virtual Float_t GetTemperature() { return fTemperature;   } 
    virtual Float_t GetMeanRap()     { return fMeanRap;       } 
    virtual Float_t GetSigmaRap()    { return fSigmaRap;      } 
    virtual Float_t GetK2Pi()        { return fK2Pi;          } 
    virtual Float_t GetP2Pi()        { return fP2Pi;          } 
    virtual Float_t GetMult()        { return fMult;          } 
    virtual Float_t GetMultWidth()   { return fMultWidth;     } 
    virtual Int_t   GetEventCounter(){ return fEventCounter;  } 

   
    virtual TPhEvent    *GetNextEvent();
    virtual TPhTrack    *GetNextTrack(Float_t mass);


  protected:
 
     Int_t    fEventCounter;       // Counter for the event number
     Float_t  fTemperature;        // Inverse slope parameter in mt
     Float_t  fMeanRap;            // Mean Rapidity of particles     
     Float_t  fSigmaRap;           // Width of rapidity distribution 
     Float_t  fK2Pi;               // K/pi ratio                      
     Float_t  fP2Pi;               // Proton/pi ratio                      
     Float_t  fMult;               // Mean multiplicity
     Float_t  fMultWidth;          // Width of multiplicity distribution

  public: 

    ClassDef(TPhRandomEvent,1)  // PHOBOS event generator
};

#endif

